<?php
	require_once('./conf.php');
	$viewer = isset($_REQUEST['viewer']);
?>
<!DOCTYPE html>
<html lang="en">
  <head>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
<?php
	if ($local) {
		echo '
			<link rel="stylesheet" href="./css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/">
			<link rel="stylesheet" href="./css/fontisto.min.css">
			<link rel="stylesheet" href="./css/metro-all.min.css">
			<link rel="stylesheet" href="./css/gridstack.min.css" />
		';
	}
	else {
		echo '
			<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.3/css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/" crossorigin="anonymous">
			<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/fontisto@v3.0.4/css/fontisto/fontisto.min.css">
			<link rel="stylesheet" href="https://cdn.metroui.org.ua/v4/css/metro-all.min.css">
			<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/gridstack.js/0.4.0/gridstack.min.css" />
		';
	}
?>
    <!-- Fancytree-->
    <link rel="stylesheet" type="text/css" href="./css/ui.fancytree.css" />
    <link rel="stylesheet" href="./css/designer.css">
    
    <title>PUMA <?php echo $viewer? '': 'Designer'; ?></title>
  </head>
<?php echo $viewer? "<body onLoad='openById()'>
		<script>
			function hideControls() {
				$('.fa-edit').hide();
				$('#tabs-content').css('background-color', 'white');
				$('.icon-pin').hide();
				$('.cursor-pointer').hide();
				$('.fa-trash-alt').hide();
				$('.icon-pin-outline').hide();
			}
			function openById() {
				ser = document.location.search;
				i = ser.indexOf('screenId=');			
				if (i > -1) {
					readOnly = true;
					openScreen(ser.substring(i+9).split('&')[0]);
				}
			}
		</script>":
	'<body>'; ?>


<div class="container-fluid" style="padding-right: 0; padding-left: 0;">

        <div class="pos-relative z-dropdown app-bar app-bar-expand" data-role="appbar" data-expand-point="md" data-role-appbar="true" style="color: white; background-color: #13709e;">
          <button type="button" class="hamburger menu-down dark hidden">
            <span class="line"></span>
            <span class="line"></span>
            <span class="line"></span>
          </button>
          <a href="./" class="brand no-hover">
            <img src="/img/logo.png" style="height: 40px; margin-right: 5px;">
            <span style="font-size: 24px; letter-spacing: 0.02em; font-style: italic; font-weight: 700;">PUMA Web</span>
          </a>

          <ul class="app-bar-menu collapsed ml-auto">
            <li><span id="user-name"></span></li>
            <!--<li><a href="#"><span class="fas fa-cogs"></span></a></li>-->
          </ul>
        </div>

	<header class="margin20 nrm nlm" style="margin-top: 2px;">
            <div class="clearfix">

            </div>



	<nav id="menu" data-role="ribbonmenu">
	    <ul class="tabs-holder"<?php echo $viewer? " style='display: none;'": ''; ?>>
		<li><a href="#screen">Screens</a></li><!--
		<li><a href="#edit">Edit</a></li>
		<li><a href="#help">Help</a></li>-->
	    </ul>

	    <div class="content-holder">
		<div class="section" id="screen">
                   <div class="group" style="padding: 0;<?php echo $viewer? " display: none;": ''; ?>">

		            <button id="new-screen" class="ribbon-button">
		                <span class="icon">
		                    <i class="fi fi-file-2"></i>
		                </span>
		                <span class="caption">New</span>
		            </button>
		            <button id="list-screens" class="ribbon-button">
		                <span class="icon">
                                    <i class="fi fi-folder"></i>
		                </span>
		                <span class="caption">Open</span>
		            </button>
		            <button id="save-screen" class="ribbon-button">
		                <span class="icon">
                                    <i class="fi fi-save"></i>
		                </span>
		                <span class="caption">Save</span>
		            </button>
		            <button id="save-screen-as" class="ribbon-button">
		                <span class="icon">
		                    <span class="fi fi-save"></span>
		                </span>
		                <span class="caption">Save As</span>
		            </button>

                   </div>

                   <div class="group" style="padding: 0;<?php echo $viewer? " display: none;": ''; ?>">

		            <button id="close-screen" class="ribbon-button">
		                <span class="icon">
		                    <span class="fas fa-door-closed"></span>
		                </span>
		                <span class="caption">Close</span>
		            </button>
		            <button id="delete-screen" class="ribbon-button">
		                <span class="icon">
		                    <span class="far fa-trash-alt"></span>
		                </span>
		                <span class="caption">Delete</span>
		            </button>
                   </div>
		
                </div>

                
		<div class="section" id="edit"<?php echo $viewer? " style='display: none'": ''; ?>>

		        <div data-role="buttonsGroup" data-cls-active="active">
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fi fi-undo"></span>
		                </span>
		                <span class="caption">Undo</span>
		            </button>
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fi fi-redo"></span>
		                </span>
		                <span class="caption">Redo</span>
		            </button>
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fas fa-eraser"></span>
		                </span>
		                <span class="caption">Erase</span>
		            </button>
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fas fa-retweet"></span>
		                </span>
		                <span class="caption">Restore</span>
		            </button>
		        </div>
                </div>   

		<div class="section" id="help"<?php echo $viewer? " style='display: none'": ''; ?>>

		        <div data-role="buttonsGroup" data-cls-active="active">
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fas fa-book"></span>
		                </span>
		                <span class="caption">Guide</span>
		            </button>
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fi fi-email"></span>
		                </span>
		                <span class="caption">Contact-us</span>
		            </button>
		            <button class="ribbon-button">
		                <span class="icon">
		                    <span class="fi fi-info"></span>
		                </span>
		                <span class="caption">About</span>
		            </button>
		        </div>
                </div>

	    </div>
	</nav>
      </header>

      <div class="grid no-gap" style="margin-bottom: 0;">
        <div class="row">

          <div class="cell colspan-1" style="flex: 1;<?php echo $viewer? " display: none;": ''; ?>">

	    <ul id="components-list-header" class="sidenav-m3" style="height: initial; width: initial; border-right: thin solid #dfdfdf;">
              <li class="title" style="border-bottom: thin solid #dfdfdf; margin: 0 10px 0 5px;">Components</li>
            </ul>
            <ul id="components-list" class="sidenav-simple sidenav-simple-expand-fs" style="width: initial; border-right: thin solid #dfdfdf; transition: initial;">
            </ul>
          </div>

          <div id="design-area" class="cell colspan-11" style="flex: 11;">

		<ul id="tabs-header" data-role="tabs" data-on-tab="onTabSelected" data-expand="true" style="margin: 5px 5px 0 5px;">
		</ul>
		<div id="tabs-content" class="border bd-default no-border-top" style="margin: 0 5px 5px 5px; padding: 8px 0; background-color: #ffffe0;">
		</div>

          </div>  
        </div>
      </div> <!--/.grid-->

    </div> <!--/.container-fluid-->
<?php
	if ($local) {
		echo '
			<script src="./js/vue.js"></script>

			<script src="./js/jquery-3.3.1.min.js"></script>
			<script src="./js/jquery-ui.min.js"></script>
			<script src="./js/lodash.min.js"></script>
			<script src="./js/Chart.bundle.min.js"></script>

			<script src="./js/moment.min.js"></script>
			<script src="./js/it.js"></script>
            <script src="js/gridstack.js"></script>
            <script src="js/gridstack.jQueryUI.js"></script>

            <script type="application/javascript" src="js/fancytree/jquery.fancytree.js"></script>	 
            <script type="application/javascript" src="js/fancytree/jquery.fancytree.dnd.js"></script>
            <script type="application/javascript" src="js/fancytree/jquery.fancytree.table.js"></script>
            <script type="application/javascript" src="js/fancytree/jquery.fancytree.columnview.js"></script>
            
            <script src="js/metro.js"></script>
		';
	}
	else {
		echo '
			<script src="https://cdn.jsdelivr.net/npm/vue@2"></script>

			<script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
			<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js" integrity="sha256-VazP97ZCwtekAsvgPBSUwPFKdrwD3unUfSGVYrahUqU=" crossorigin="anonymous"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.11/lodash.js" integrity="sha256-vS9J2VYhvwAfh2znnLdkhemFPEpx6YoZEhExqBPT5ys=" crossorigin="anonymous"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.3/Chart.bundle.js"></script>

			<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/it.js"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/gridstack.js/0.4.0/gridstack.min.js"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/gridstack.js/0.4.0/gridstack.jQueryUI.min.js"></script>

			<link href="./lib/fancytree-2.3.0/src/skin-pwma/ui.fancytree.css" class="skinswitcher" rel="stylesheet" type="text/css">
			<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.fancytree/2.37.0/jquery.fancytree-all.min.js" type="text/javascript"></script>
            
			<!--script src="https://cdnjs.cloudflare.com/ajax/libs/metro/4.2.33/js/metro.js"></script-->
			<script src="./js/metro.js"></script>
		';
	}
?>

	<script src="./js/conf.js"></script>
	<script src="./js/designer.js"></script>

    <div id="screens-list-dialog" class="dialog" data-role="dialog">
      <div class="dialog-title" style="padding-right: 10px;">
        Screen Selection 
        <input id="screens-list-filter" type="text" placeholder="search box..." style="display: inline; width: 50%; float: right; border-radius: 20px; font-size: 13px; box-shadow: none; color: #333;">
      </div>
      <div id="all-available-screens" style="order: 2; vertical-align: middle; padding-left: 24px; position: relative; top: 2px;">
        <ul data-role="listview" data-view="table" class="listview view-table" data-role-listview="true" style="vertical-align: middle;">
          <li class="node on-hover-no-bg-color on-hover-no-pointer" style="vertical-align: middle;">
            <div class="data" style="vertical-align: middle;">
              <div class="caption" style="padding-left: 0; vertical-align: middle; font-style: italic;">browse all available screens</div>
            </div> 
          </li>
        </ul>
      </div>
      <div id="back-to-previous-list" style="order: 2; vertical-align: middle; padding-left: 10px; position: relative; top: 2px; display: none;">
        <ul data-role="listview" data-view="table" class="listview view-table" data-role-listview="true" style="vertical-align: middle;">
          <li class="node on-hover-no-bg-color on-hover-underline" style="vertical-align: middle;" onclick="showFolders();">
            <span class="icon"><span class="mif-chevron-left"></span></span>
            <div class="data" style="vertical-align: middle;">
              <div class="caption" style="padding-left: 0; vertical-align: middle; font-style: italic;">back to main listing</div>
            </div>
          </li>
        </ul>
      </div>
      <div class="dialog-content" style="border-top: none; height: 500px; overflow-y: auto; margin-top: 0; padding-top: 5px; order: 3;">
      </div>
      <div class="dialog-actions">
        <button class="button js-dialog-close">Close</button>
      </div>
    </div>

    <div id='tree' style='background: white; display: none; overflow-y:auto; max-height:400px'></div>
    <div id='screens' style='background: white; display: none; overflow-y:auto; max-height:400px'></div>

    <div id='formula'></div>
  </body>
</html>
