<?php
	session_start();
	$username = '';
	require_once("./conf.php");
	require_once("./auth.php");
	require_once("./uti.php");
	$sql = open_db();
	if (isset($_SESSION['token'])) {
		$yy = date('Y');
		$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
		if (!empty($data)) {
			$un = explode('@', $data[0]['username']);
			$username = strtolower($un[0]);
		}
	}
	else if (isset($_REQUEST['puma_email'])) {
		$yy = date('Y');
		$username = $_REQUEST['puma_email'];
		$password = $_REQUEST['puma_password'];
		$r = puma_auth($username, $password);
		if ($r != "Login OK") {die("login failed<br>$r<br>");}
		for ($i=0,$token=""; $i<5; $i++) {
			$token .= sprintf("%02x", rand(0, 256));
		}
		$_SESSION['token'] = $token;
		$data = $sql->sql_secure("INSERT INTO userlog_$yy (date,webtoken,username,ip) VALUES (NOW(),$1,$2,$3)", array($token, $username, $_SERVER['REMOTE_ADDR']),1);
	}
	if (isset($_REQUEST['svg'])) {
		$branch = empty($_REQUEST['branch'])? 'master': strip_tags($_REQUEST['branch']);
		$query = "SELECT s,title FROM screen WHERE id=$1";
		$data = $sql->sql_secure($query, array($_REQUEST['svg']));
		if (isset($_REQUEST['debug'])) {echo "query: $query;<br>\nerr: ".$sql->sql_error()."<br>\ndata: <pre>"; print_r($data); echo "</pre>";}
		$contents = $data[0]['s'];
		$context = stream_context_create(array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
		if (GITLAB_API) {
			$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
			if (isset($_REQUEST['debug'])) {echo GITLAB_API_URL."/repository/files/screens%2Fuser{$udata[0]['user_id']}%2F{$data[0]['title']}/raw/?ref=$branch<br>\n";}
			$contents = file_get_contents(GITLAB_API_URL."/repository/files/screens%2Fuser{$udata[0]['user_id']}%2F{$data[0]['title']}/raw/?ref=$branch", false, $context);
		}
		$a = explode("<svg", $contents);
		$b = explode("</svg>", $a[1]);
		if (isset($_REQUEST['save'])) {
			$entityBody = file_get_contents('php://input');
			// file_put_contents('./editor.log', date('Y-m-d H:i:s ').$a[0].$entityBody.$b[1], FILE_APPEND | LOCK_EX); exit();
			$content = strtr($entityBody, array('data-display'=>'display','data-onclick'=>'onclick','<stopg/>'=>'</g>'));
			while (($lastPos = strpos($content, '<startg'))!== false) {
				$end = strpos($content, '/>', $lastPos);
				$content = substr_replace($content, '>', $end, 2);
				$content = substr_replace($content, '<g', $lastPos, 7);
			}
			$query = "UPDATE screen SET s=$1 WHERE id=$2";
			$idata = $sql->sql_secure($query, array($a[0].$content.$b[1], $_REQUEST['svg']));
			$err = $sql->sql_error();
			if (!empty($err)) file_put_contents('./editor.log', date('Y-m-d H:i:s ')."$err - $query - {$_REQUEST['svg']}\n", FILE_APPEND | LOCK_EX);
			if (GITLAB_API) {
				$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
				$resp = gitlab_post('update', 'screens/user'.$udata[0]['user_id'].'/'.$data[0]['title'], $a[0].$content.$b[1], 'SVG edit', $branch);
			}
			die($err);
		}
		$content = $b[0];
		if (!isset($_REQUEST['nofilter'])) {
			$content = strtr($b[0], array('display'=>'data-display','onClick'=>'data-onclick','onclick'=>'data-onclick','</g>'=>'<stopg/>'));
			while (($lastPos = strpos($content, '<g'))!== false) {
				$end = strpos($content, '>', $lastPos);
				$content = substr_replace($content, '/>', $end, 1);
				$content = substr_replace($content, '<startg', $lastPos, 2);
			}
		}
		die("<svg{$content}</svg>");
	}
	if (empty($username)) {
		emit_header();
		die("&nbsp;Page available only for authorized users. If you are authorized, please enter<br><br><form method='post' action='?{$_SERVER['QUERY_STRING']}'>&nbsp;username <input type='text' name='puma_email'><br><br>&nbsp;password <input type='password' name='puma_password'> <input type='submit'></form>.");
	}
	else if (!is_dir("./spa/usr/".$username)) {
		emit_header();
		die('<div style="margin: 10px;">'.
			"Page available only for authorized users.<br>Your username still isn't authorized, please read and accept this notice
		<iframe style='width: 100%; height: 20em;' src='./spa/usr/licence_1.1.html'></iframe>
		and send an <a href='mailto:{$admin_email}?subject=Authorization%20request&body=Please%20authorize%20{$username}%20as%20PUMA%20advanced%20developer%2E%20I%20accept%20the%20developer%20notice%201%2E0'>authorization request</a>.</div>");
	}
	if (!empty($_REQUEST['open_json'])) {open_json();}
	open_editor();

	// ----------------------------------------------------------------
	// append screen to starter
	function starter_append($name) {
		global $sql, $username, $local, $host;
		$default_starter = trim(file_get_contents('./default_starter.json'), "]\n\r");
		$data = $sql->sql_secure("SELECT screens FROM starter WHERE username = $1", array($username));
		if (isset($_REQUEST['debug'])) {echo "data: <pre>"; print_r($data); echo "</pre>";}
		$screen = '	{"title":"'.$name.'","component":"'.$host.'/spa/index.html?version=usr/'.$username.'/'.$name.'"}';
		if (isset($_REQUEST['s'])) $screen = '	{"title":"'.$name.'","component":"'.$host.'/spa/index.html?s='.$name.'"}';
		if (empty($data)) {
			if ($local) {
				$starter = $default_starter.",\n$screen\n]";
			}
			else {
				$starter = "[\n$screen\n]";
			}
			$data = $sql->sql_secure("INSERT INTO starter (screens,username, datemodified) VALUES ($1, $2, NOW())", array($starter, $username));
		}
		else {
			$starter = trim($data[0]['screens'],"] \n\r\t");
			if (strpos($starter,'usr/'.$username.'/'.$name)!==false) return('Warning: already present');
			$starter .= ",\n\t$screen\n]";
			$data = $sql->sql_secure("UPDATE starter SET screens = $1, datemodified=NOW() WHERE username = $2", array($starter, $username));
		}
		if (isset($_REQUEST['debug'])) {echo "INSERT INTO starter (screens,username, datemodified) VALUES (\"$starter\", \"$username\", NOW())<br>\ndata: <pre>"; print_r($data); echo "</pre>\n".$sql->sql_error()."<br>\n";}
		return('OK');
	}

	// ----------------------------------------------------------------
	// emit header
	function emit_header() {
		global $username, $local;
		echo "		<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>\n";
		echo '<nav class="navbar navbar-default">
	  <div class="container-fluid bg-info">
		<div class="navbar-header">
		  <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#myNavbar">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>                        
		  </button>
		  <a class="navbar-brand" href="./starter.php"><img src="/img/puma.svg" style="width:40px; height:40px; margin-top: -10px; margin-left: -5px; display: inline;"> 
		  <span style="font-size: 150%; font-weight: bolder; color: black">PUMA Editor
		  <!--h2 style="color: black">PUMA</h2--></span></a>
		  <ul style="float: right"><!--class="nav navbar-form navbar-right"-->
			 <div>';
		if (!empty($username)) {
			echo '
			  <form method="post" action="./starter.php" style="margin: 0px;">welcome '.$username.' <button type="submit" name="logout" class="btn btn-default">Logout</button></form>';
		}
		echo '
			<script>
				document.body.style.fontSize = "2em";
				if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/)!=null && window.innerWidth>600) {
					document.body.style.fontSize = "5em";
				}
			</script>
			 </div>
		  </ul>
		</div>
	  </div>
	</nav>';
	}


	// ----------------------------------------------------------------
	// update gitlab
	function gitlab_post($action, $file_path, $content, $message='',$branch='master') {
		if (empty($message)) $message = "$action ".basename($file_path);
		$contentscreen = '"content": '.json_encode($content);
		if ($action=='move') $contentscreen = '"previous_path": "'.$content.'"';
		$payload = '{
		  "branch": "'.$branch.'",
		  "commit_message": "'.$message.'",
		  "actions": [
			{
			  "action": "'.$action.'",
			  "file_path": "'.$file_path.'",
			  '.$contentscreen.'
			}
		  ]
		}';

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, GITLAB_API_URL.'/repository/commits');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

		$headers = array();
		$headers[] = 'PRIVATE-TOKEN: '.GITLAB_API_TOKEN;
		$headers[] = 'Content-Type: application/json';
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

		$result = curl_exec($ch);
		if (curl_errno($ch)) {
			die('Error:' . curl_error($ch));
			file_put_contents('./editor.log', date('Y-m-d H:i:s ').curl_error($ch)."\n", FILE_APPEND | LOCK_EX);

		}
		curl_close($ch);
		file_put_contents('./editor.log', date('Y-m-d H:i:s ')."$result\n", FILE_APPEND | LOCK_EX);
		return $result;
	}


	// ----------------------------------------------------------------
	// emit json file editor dialog
	function open_json() {
		global $username, $local, $sql;
		$s = isset($_REQUEST['s'])? '&s': ''; 
		if (isset($_REQUEST['save'])) {
			if (isset($_REQUEST['s'])) {
				die(json_encode($_REQUEST));

				$f = explode('/', $_REQUEST['file']);
				$file = array_pop($f);
				$category = null;
				if (!empty($f)) $category = "{'".implode("','", $f)."'}";
				$now = date('Y-m-d H:i:s');
				$query = "UPDATE screen (last_update,category,s) VALUES ('$now', $1, $2) WHERE username=$3 AND title=$4";
				$stmt = $sql->sql_secure($query, array($category, $_REQUEST['content'], $username, $file));
				$err = $sql->sql_error();
				header("Content-Type: application/json");
				die(json_encode(array('name'=>$_REQUEST['file'], 'query'=>$query, 'err'=>$err)));
			}
		}
		$screendata = $sql->sql_secure("SELECT * FROM screen WHERE id = $1", array($_REQUEST['open_json']));
		$document_title = $screendata[0]['title'];
		$mode = "application/json\",\ngutters: [\"CodeMirror-lint-markers\"],\nlint: true,\ntrash:\"trash";
		$contents = json_encode(json_decode($screendata[0]['content']), JSON_PRETTY_PRINT);
		$text = "	<div style='display: flex; height: 96%'>
			<textarea style='min-width: 900px; width: 99%; max-height: 1200px; overflow-y: scroll' name='edited_text' id='edited_text'>".strtr($contents,array('&'=>'&amp;','<'=>'&lt;'))."</textarea>
			</div>\n	</div>\n	</div>";
		echo "<!DOCTYPE html>\n	<!--html lang='en'-->\n	<html>
		<head>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>
		<body style='padding:0;'>

		<form method='post' action='?save$s&open_json={$_REQUEST['open_json']} '>
		<div style='background-color: #d9edf7;'>&nbsp;
		<img src='/img/puma.svg' style='width:40px; height:40px; margin-top: 3px; margin-left: 3px; cursor: pointer;' onClick='document.location = \"./editor.php?p$s\"'>
		<input type='submit' value='save' onClick=\"document.getElementById('line').value = editor.lineAtHeight(editor.getScrollInfo().top, 'local')\">
		<input type='text' name='commit' value='Update $document_title'>
		branch <input type='text' name='branch' size='6' value='master'>
		<input type='hidden' id='line' name='line' value='1'></div>
		$text
		</form>\n";
		emit_editor_js($document_title, $mode, "'100%'");
		die(''); // die('json_encode($screendata)');
	}

	// ----------------------------------------------------------------
	// emit file editor
	function emit_editor_js($document_title, $mode, $sizeX) {
		global $username, $local;
		$sizeY = '65';
		$line = isset($_REQUEST['line'])? $_REQUEST['line']: '1';
		$wrapping = 'lineWrapping: false,';
        if (!$local) {
        	echo "
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/codemirror.min.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/matchesonscrollbar.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/dialog/dialog.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/lint.css'>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/codemirror.min.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/edit/matchbrackets.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/jump-to-line.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/matchesonscrollbar.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/searchcursor.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/search.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/scroll/annotatescrollbar.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/dialog/dialog.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/htmlmixed/htmlmixed.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/xml/xml.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/javascript/javascript.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/css/css.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/clike/clike.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/php/php.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/sql/sql.js'></script>
        		<script src='https://unpkg.com/jshint@2.9.6/dist/jshint.js'></script>
        		<script src='https://unpkg.com/jsonlint@1.6.3/web/jsonlint.js'></script>
        		<script src='https://unpkg.com/csslint@1.0.5/dist/csslint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/javascript-lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/json-lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/css-lint.js'></script>\n";
        }
        else {
        	echo "
        		<link rel='stylesheet' href='./lib/codemirror/lib/codemirror.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/search/matchesonscrollbar.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/dialog/dialog.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/lint/lint.css'>
        		<script src='./lib/codemirror/lib/codemirror.js'></script>
        		<script src='./lib/codemirror/addon/edit/matchbrackets.js'></script>
        		<script src='./lib/codemirror/addon/search/jump-to-line.js'></script>
        		<script src='./lib/codemirror/addon/search/matchesonscrollbar.js'></script>
        		<script src='./lib/codemirror/addon/search/searchcursor.js'></script>
        		<script src='./lib/codemirror/addon/search/search.js'></script>
        		<script src='./lib/codemirror/addon/scroll/annotatescrollbar.js'></script>
        		<script src='./lib/codemirror/addon/dialog/dialog.js'></script>
        		<script src='./lib/codemirror/mode/htmlmixed/htmlmixed.js'></script>
        		<script src='./lib/codemirror/mode/xml/xml.js'></script>
        		<script src='./lib/codemirror/mode/javascript/javascript.js'></script>
        		<script src='./lib/codemirror/mode/css/css.js'></script>
        		<script src='./lib/codemirror/mode/clike/clike.js'></script>
        		<script src='./lib/codemirror/mode/php/php.js'></script>
        		<script src='./lib/codemirror/mode/sql/sql.js'></script>
        		<script src='https://unpkg.com/jshint@2.9.6/dist/jshint.js'></script>
        		<script src='https://unpkg.com/jsonlint@1.6.3/web/jsonlint.js'></script>
        		<script src='https://unpkg.com/csslint@1.0.5/dist/csslint.js'></script>
        		<script src='./lib/codemirror/addon/lint/lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/javascript-lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/json-lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/css-lint.js'></script>\n";
        }
        echo "
        	<script>
        		var width = window.innerWidth
        			|| document.documentElement.clientWidth
        			|| document.body.clientWidth;
        		if (width < 1050) {
        			document.getElementById('docBr').style.display = 'block';
        			document.getElementById('doc').style.float = '';
        		}
        		var height = window.innerHeight
        			|| document.documentElement.clientHeight
        			|| document.body.clientHeight;
        		function addblock() {
        			var num = 15;
        			var cursor = editor.getSearchCursor('clearfix'); 
        			var item = cursor.findNext();
        			var insertLine = cursor.from().line;
        			cursor = editor.getSearchCursor('#collapse', {line: insertLine, ch: 0});
        			item = cursor.findPrevious();
        			var collapseLine = cursor.to();
        			var collapseLine2 = {line: collapseLine.line, ch: collapseLine.ch+2};
        			var range = editor.getRange(collapseLine, collapseLine2);
        			var num = range[1]=='\"'? (range[0]-0)+1: (range-0)+1;
        			console.log('getSearchCursor', insertLine, collapseLine, num);
        			var     block = '		<div class=\"col-sm-6 col-md-4 panel panel-primary\" >\\n';
        			block = block + '			<a id=\"id'+num+'\" role=\"button\" class=\"btn btn-primary btn-block\" data-toggle=\"collapse\" href=\"#collapse'+num+'\">block'+num+'</a>\\n';
        			block = block + '			<div id=\"collapse'+num+'\" class=\"panel-collapse collapse\">\\n';
        			block = block + '				<ul class=\"list-group\">\\n';
        			block = block + '					<li class=\"list-group-item\">\\n';
        			block = block + '						<label for=\"item'+num+'_0\">label</label>\\n';
        			block = block + '						<input disabled type=\"text\" class=\"puma form-control\" id=\"item'+num+'_0\" value=\"N.A.\" data-src=\"\" />\\n';
        			block = block + '					</li>\\n';
        			block = block + '				</ul>\\n';
        			block = block + '			</div>\\n';
        			block = block + '		</div>\\n';
        			editor.replaceRange(block, {line: insertLine, ch: 0});
        		}
        		function varTable(dim) {
        			var d = dim.split('x');
        			var row = d[0];
        			var col = d[1];
        			var table = '<div class=\\'table-responsive\\' id=\\'tab1\\'>\\n	<table class=\\'table  table-hover my-4\\'>\\n';
        			table = table + '<caption class=\\'font-italic\\'>Tabella n. 1 - Titolo</caption>\\n<thead>\\n		<tr>\\n';
        			for (c=0; c<col; c++) {
        				table = table + '<th scope=\\'col\\'></th>\\n';
        			}
        			table = table + '</tr>\\n	</thead>\\n	<tbody>\\n';
        			for (r=0; r<row; r++) {
        				table = table + '<tr>\\n		<th scope=\\'row\\'></th>\\n';
        				for (c=0; c<col; c++) {
        					table = table + '		<td></td>\\n';
        				}
        				table = table + '</tr>\\n';
        			}
        			return table + '	</tbody>\\n	</table>\\n</div>';
        		}
        		var myTextarea = document.getElementById('edited_text');
        		var editor = CodeMirror.fromTextArea(myTextarea, {
        			lineNumbers: true,
        			$wrapping
        			matchBrackets: true,
        			mode: \"$mode\",
        			indentUnit: 4,
        			indentWithTabs: true,
        			extraKeys: {\"Alt-F\": \"findPersistent\"}
        		});
        		document.title = '$document_title';
        		editor.setSize($sizeX, height - $sizeY);
        		editor.scrollTo(null, editor.heightAtLine($line-1,'local'));
        		function mySplit() {
        			var text = editor.getValue('\\n').split('\\n');
        			var i;
        			var line = '';
        			for (j=0; j<text.length; j++) {
        				i = text[j].lastIndexOf(' ', 80);
        				while (i>0) {
        					line = line+'\\n'+text[j].slice(0,i); 
        					text[j] = text[j].slice(i+1);
        					i = text[j].lastIndexOf(' ', 80);
        				}
        				line = line+'\\n'+text[j];
        			}
        			console.log(line);
        		}
        		if (document.getElementById('preview')) {
        			document.getElementById('preview').style['max-height'] = height - $sizeY;
        			editor.on('change', function(){
        				document.getElementById('preview').innerHTML = editor.getValue();
        				$('.panel-collapse').removeClass('panel-collapse');
        				$('.collapse').removeClass('collapse');
        				if (typeof initializeNotSubscribed == 'function') initializeNotSubscribed();
        			});
        		}
        		</script>
        			<script type='text/javascript' src='./spa/js/conf.js'></script>
        			<script type='text/javascript' src='./spa/js/d3.v3.min.js'></script>
        			<script type='text/javascript' src='./spa/js/d3_gauge.js'></script>
        			<script type='text/javascript' src='./spa/js/puma.js'></script>
        			<script type='text/javascript'>initVar();$('.panel-collapse').removeClass('panel-collapse');$('.collapse').removeClass('collapse');</script>
        		</body>
		\n";
	}

	// ----------------------------------------------------------------
	// emit file editor
	function emit_editor($dest, $name) {
		global $username, $local, $sql, $host;
		$ext = pathinfo($dest, PATHINFO_EXTENSION);
		$parse = explode('/',$dest);
		$document_title = $title = array_pop($parse);
		if (strlen(implode('/',$parse))>2) $document_title .= ' ('.implode('/',$parse).')';
		$mode = "application/x-httpd-php";
		if ($ext=='sql') $mode = "text/x-sql";
		if ($ext=='js') $mode = "javascript\",\ngutters: [\"CodeMirror-lint-markers\"],\nlint: true,\ntrash:\"trash";
		if ($ext=='json') $mode = "application/json\",\ngutters: [\"CodeMirror-lint-markers\"],\nlint: true,\ntrash:\"trash";
		if ($ext=='css') $mode = "css\",\ngutters: [\"CodeMirror-lint-markers\"],\nlint: true,\ntrash:\"trash";

		if (isset($_REQUEST['save'])) {
			$line = isset($_REQUEST['line'])? $_REQUEST['line']: '1';
			if (isset($_REQUEST['s'])) {
				$file = $_REQUEST['open_editor'];
				$now = date('Y-m-d H:i:s');
				if (GITLAB_API) {
					$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
					$resp = gitlab_post('update', 'screens/user'.$udata[0]['user_id'].'/'.$file, $_REQUEST['edited_text'], $_REQUEST['commit'], $_REQUEST['branch']);
				}
				// todo: update category
				$query = "UPDATE screen SET last_update='$now', s= $1 WHERE username=$2 AND title=$3";
				$stmt = $sql->sql_secure($query, array($_REQUEST['edited_text'], $username, $file));
				$err = $sql->sql_error();
				// print_r($_REQUEST); exit();
				header("Location: ".$_SERVER['PHP_SELF']."?open_editor={$_REQUEST['open_editor']}&s&line=$line&id={$_REQUEST['id']}".(isset($_REQUEST['nopreview'])? '&nopreview': '')."&err=$err");
				exit(0);
				die("$query - $username, $file<br>ERR: $err");
			}
			$_upload_dir = dirname($_SERVER["SCRIPT_FILENAME"]);
			if (strlen($ext)) {
				$back = "../back/".trim(strtr($dest,array($_upload_dir=>'',".$ext"=>date('_Y-m-d').".$ext")),'._');
			}
			else {
				$back = "../back/".trim(strtr($dest,array($_upload_dir=>'')),'._').date('_Y-m-d');
			}
			// die("$dest - $back");
			if (file_exists($dest) and !file_exists($back)) rename($dest, $back);
			file_put_contents($dest, $_REQUEST['edited_text']);
			header("Location: ".$_SERVER['PHP_SELF']."?open_editor={$_REQUEST['open_editor']}&line=$line");
			exit(0);
		}
		$context = stream_context_create(array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
		$help = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;add:
			<input type='submit' value='block' onClick=\"addblock(); return false;\">
			<input type='submit' value='img' onClick=\"editor.replaceRange('<img class=\'puma\' style=\'height: 24px;\' id=\'img0\' src=\'./img/ledgrey.png\' data-src=\'\' />', editor.getCursor()); return false;\">
			<input type='submit' value='chart' onClick=\"editor.replaceRange('<iframe style=\'width:100%;height:300px;\' id=\'chart0\' src=\'./spa/chart.html?ts=tango://tom.ecs.elettra.trieste.it:20000/sr/diagnostics/dcct_s4/current&minutes=1440\' ></iframe>', editor.getCursor()); return false;\">
			<input type='submit' value='gauge' onClick=\"editor.replaceRange('<span class=\'puma gauge\' id=\'gauge0\' data-src=\'\' />', editor.getCursor()); return false;\">
			&nbsp;&nbsp;
			<input type='submit' value='table' onClick=\"editor.replaceRange(varTable(document.getElementById('tabSize').value), editor.getCursor()); return false;\">
			<input type='text' value='3x3' size='2' id='tabSize'>&nbsp;&nbsp;
			<!--input type='submit' value='sup' onClick=\"var sel = []; if (editor.somethingSelected()) {sel = editor.getSelections(); for (i=0; i<sel.length; i++) sel[i] = '<sup>'+sel[i]+'</sup>'; editor.replaceSelections(sel);} else editor.replaceRange('<sup></sup>', editor.getCursor()); return false;\">
			<input type='submit' value='sub' onClick=\"var sel = []; if (editor.somethingSelected()) {sel = editor.getSelections(); for (i=0; i<sel.length; i++) sel[i] = '<sub>'+sel[i]+'</sub>'; editor.replaceSelections(sel);} else editor.replaceRange('<sub></sub>', editor.getCursor()); return false;\">
			<input type='submit' value='<i>' onClick=\"var sel = []; if (editor.somethingSelected()) {sel = editor.getSelections(); for (i=0; i<sel.length; i++) sel[i] = '<i>'+sel[i]+'</i>'; editor.replaceSelections(sel);} else editor.replaceRange('<i></i>', editor.getCursor()); return false;\">
			<input type='submit' value='<b>' onClick=\"var sel = []; if (editor.somethingSelected()) {sel = editor.getSelections(); for (i=0; i<sel.length; i++) sel[i] = '<b>'+sel[i]+'</b>'; editor.replaceSelections(sel);} else editor.replaceRange('<b></b>', editor.getCursor()); return false;\"-->
			<input type='submit' value='link' onClick=\"var sel = []; if (editor.somethingSelected()) {sel = editor.getSelections(); for (i=0; i<sel.length; i++) sel[i] = '<a href=\'\'>'+sel[i]+'</a>'; editor.replaceSelections(sel);} else editor.replaceRange('<a href=\'\'></a>', editor.getCursor()); return false;\">
			<br style='display: none;' id='docBr'>
		  <span style='float: right; margin-top: 10px;' id='doc'>&nbsp;documentation: 
			<a href='https://www.w3schools.com/tags/default.asp' target='_blank'>HTML</a> - 
			<a href='https://www.w3schools.com/bootstrap4/default.asp' target='_blank'>Bootstrap</a> - 
			<a href='https://www.w3schools.com/jquery/' target='_blank'>JQuery</a> - 
			<a href='./spa/index.html?version=template' target='_blank'>PUMA</a> - 
			<a href='/ujive.php' target='_blank'>&mu;jive</a>&nbsp;&nbsp;</span>";
		if (GITLAB_API) {
			$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
			$contents = file_get_contents(GITLAB_API_URL."/repository/files/screens%2Fuser{$udata[0]['user_id']}%2F{$_REQUEST['open_editor']}/raw/?ref=master", false, $context);
		}
		else $contents = file_get_contents((isset($_REQUEST['s'])? strtr($host,array('https'=>'http')).'/screens.php?s=open&id='.($_REQUEST['id']-0): $dest), false, $context);
			 // <textarea rows='40' cols='120' name='edited_text' id='edited_text'>".strtr($contents,array('&'=>'&amp;','<'=>'&lt;'))."</textarea>
		if (isset($_REQUEST['nopreview'])) {
			$text = "	<div style='display: flex; height: 96%'>\n		<textarea width: 100%; overflow-y: scroll' name='edited_text' id='edited_text'>".strtr($contents,array('&'=>'&amp;','<'=>'&lt;'))."</textarea>\n	</div>\n";
			$sizeX = "'100%'";
		}
		else {
			$text = "	<div style='display: flex; height: 96%'>
				<textarea style='min-width: 900px; width: 75%; max-height: 1200px; overflow-y: scroll' name='edited_text' id='edited_text'>".strtr($contents,array('&'=>'&amp;','<'=>'&lt;'))."</textarea>
				<div id='preview' style='display: block; min-width: 600px; max-height: 1200px; overflow-y: scroll'><div id='mainPage' style='padding:0;'><div id='main'>$contents
			</div>\n	</div>\n	</div>	</div>\n";
			$sizeX = "'75%'";
		}
		$s = isset($_REQUEST['s'])? '&s': '';
		$view = isset($_REQUEST['s'])? "./spa/index.html?s=$name": "./spa/index.html?version=usr/$username/{$name}";
		// else $help = "<input type='submit' value='split' onClick=\"mySplit(); return false;\"><br> ";
		echo "<!DOCTYPE html>
	<!--html lang='en'-->
	<html>
		<head>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>
		<body style='padding:0;'>

		<form method='post' action='?save$s&open_editor={$_REQUEST['open_editor']}&id={$_REQUEST['id']}".(isset($_REQUEST['nopreview'])? '&nopreview': '')."'> 
		<div style='background-color: #d9edf7;'>&nbsp;
		<img src='/img/puma.svg' style='width:40px; height:40px; margin-top: 3px; margin-left: 3px; cursor: pointer;' onClick='document.location = \"./editor.php?p$s\"'>
		<input type='submit' value='save' onClick=\"document.getElementById('line').value = editor.lineAtHeight(editor.getScrollInfo().top, 'local')+1;\">
		<input type='text' name='commit' value='Update $name' title='Commit message'>
		branch <input type='text' name='branch' size='6' value='master' title='Target Branch'>&nbsp;&nbsp;
		<a href='$view' target='_blank'>view</a><!--span class='btn btn-primary glyphicon glyphicon-save-file'></span--> $help
		<input type='hidden' id='line' name='line' value='1'></div>
		$text
		</form>\n";
		emit_editor_js($document_title, $mode, $sizeX);
		exit(0);
	}

	// ----------------------------------------------------------------
	// emit file editor dialog
	function open_editor() {
		global $username, $local, $sql, $host, $admin;
		$yy = date('Y');
		$default = '<div id="main" class="container-fluid">
	<h4 id="titleId" class="text-primary text-center">Title</h4>
	<div class="row panel-group">
		<div class="col-sm-6 col-md-3 panel panel-primary">
			<a id="statusBtn" role="button" class="btn btn-primary btn-block" data-toggle="collapse" href="#collapse1">Status</a>
			<div id="collapse1" class="panel-collapse collapse">
				<ul class="list-group">
					<li class="list-group-item">
					</li>
				</ul>
			</div>
		</div>
		<div class="clearfix visible-sm"></div>
	</div>
</div>';
		$s = isset($_REQUEST['s'])? '&s': ''; 
		$now = date('Y-m-d H:i:s');
		if (!empty($_REQUEST['mv'])) {
			emit_header();
			die("&nbsp;Source screen: {$_REQUEST['mv']} - destination screen: <input type='text' id='dest'><br><br>
			&nbsp;<button onClick=\"document.location = './editor.php?move={$_REQUEST['mv']}$s&dest='+document.getElementById('dest').value; return false;\">rename</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<button onClick=\"document.location = './editor.php?copy={$_REQUEST['mv']}$s&dest='+document.getElementById('dest').value; return false;\">copy</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			");
		}
		if (!empty($_REQUEST['move'])) {
			if (isset($_REQUEST['s'])){
				emit_header();
				$data = $sql->sql_secure("SELECT COUNT(*) AS n, s FROM screen WHERE username=$1 AND title=$2 UNION SELECT COUNT(*) AS n, '' AS s FROM screen WHERE username=$1 AND title=$3", array($username, $_REQUEST['copy'], $_REQUEST['dest']));
				if ($data[0]['n']=='0') die("Error: screen {$_REQUEST['move']} doesn't exists.<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
				if ($data[1]['n']>0) die("Error: screen {$_REQUEST['dest']} already exists.<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
				if (GITLAB_API) {
					$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
					$resp = gitlab_post('move', 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['dest'], 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['move']);
				}
				$query = "UPDATE screen SET title=$1 WHERE username=$2 AND title=$3";
				$stmt = $sql->sql_secure($query, array($_REQUEST['dest'], $username, $_REQUEST['move']));
				$err = $sql->sql_error();
				die(($err? "Error: $err": "Screen {$_REQUEST['move']} has been moved to {$_REQUEST['dest']}")."<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
			}
			else {
				$src = "./spa/usr/$username/{$_REQUEST['move']}.html";
				if (!file_exists($src)) die("Error: screen {$_REQUEST['move']} not found.<br><br>\n<a href='./editor.php'>Continue</a><br><br>\n");
				$dest = "./spa/usr/$username/{$_REQUEST['dest']}.html";
				if (file_exists($dest)) die("Error: screen {$_REQUEST['dest']} already exists.<br><br>\n<a href='./editor.php'>Continue</a><br><br>\n");
				rename($src, $dest);
			}
		}
		if (!empty($_REQUEST['copy'])) {
			if (isset($_REQUEST['s'])){
				emit_header();
				$query = "SELECT 0 AS ob, 1 AS n, s FROM screen WHERE username=$1 AND title=$2 UNION SELECT 1 AS ob, COUNT(*) AS n, '' AS s FROM screen WHERE username=$1 AND title=$3 ORDER BY ob";
				if (isset($_REQUEST['debug'])) echo strtr($query, array('$1'=>$username, '$2'=>$_REQUEST['copy'], '$3'=>$_REQUEST['dest'])).';<br>';
				$data = $sql->sql_secure($query, array($username, $_REQUEST['copy'], $_REQUEST['dest']));
				if (isset($_REQUEST['debug'])) {echo "data: <pre>"; print_r($data); echo "</pre><br>";exit();} 
				if (empty($data[0])) die("Error: screen {$_REQUEST['copy']} doesn't exists.<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
				if ($data[1]['n']>0) die("Error: screen {$_REQUEST['dest']} already exists.<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
				if (GITLAB_API) {
					$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
					$resp = gitlab_post('create', 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['dest'], $data[0]['s']);
				}
				$query = "INSERT INTO screen (created_on, last_update, s, username, title, ip) VALUES ('$now', '$now', $1, $2, $3, '{$_SERVER['REMOTE_ADDR']}')";
				$stmt = $sql->sql_secure($query, array($data[0]['s'], $username, $_REQUEST['dest']));
				$err = $sql->sql_error();
				if (isset($_REQUEST['debug'])) echo "$query;<br><br><textarea>{$data[0]['s']}</textarea><br><br>{$_REQUEST['dest']}";
				die(($err? "Error: $err": "Screen {$_REQUEST['copy']} copied to {$_REQUEST['dest']}")."<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
			}
			else {
				$src = "./spa/usr/$username/{$_REQUEST['copy']}.html";
				if (!file_exists($src)) {emit_header(); die("Error: screen {$_REQUEST['copy']} not found.<br><br>\n<a href='./editor.php'>Continue</a><br><br>\n");}
				$dest = "./spa/usr/$username/{$_REQUEST['dest']}.html";
				if (file_exists($dest)) {emit_header(); die("Error: screen {$_REQUEST['dest']} already exists.<br><br>\n<a href='./editor.php'>Continue</a><br><br>\n");}
				copy($src, $dest);
			}
		}
		if (!empty($_REQUEST['remove'])) {
			emit_header();
			die("&nbsp;Are you sure to remove {$_REQUEST['remove']}?<br><br>&nbsp;<a href='./editor.php?del={$_REQUEST['remove']}$s'>yes</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href='./editor.php?p$s'>cancel</a>");
		}
		if (!empty($_REQUEST['del'])) {
			emit_header();
			if (!isset($_REQUEST['s']))	unlink("./spa/usr/$username/{$_REQUEST['del']}.html");
			else {
				if (GITLAB_API) {
					$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
					$resp = gitlab_post('delete', 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['del'], '');
				}
				if (isset($_REQUEST['debug'])) echo "SELECT (CASE WHEN valid_until > NOW() THEN 'Y' ELSE 'N' END) AS valid FROM screenlog_$yy WHERE username=$1 AND title=$2;<br>\n";
				$data = $sql->sql_secure("SELECT (CASE WHEN valid_until > NOW() THEN 'Y' ELSE 'N' END) AS valid FROM screenlog_$yy WHERE username=$1 AND title=$2", array($username, $_REQUEST['del']));
				if (empty($data) || $data[0]['valid']=='N') {
					$query = "SELECT * FROM screen WHERE username=$1 AND title=$2";
					$d = $sql->sql_secure($query, array($username, $_REQUEST['del']));
					if (isset($_REQUEST['debug'])) echo "$query;<br>\n".$sql->sql_error()."<br>\n";
					$query = "INSERT INTO screenlog_$yy (id, username, title, valid_until, s, category) VALUES ({$d[0]['id']}, $1,$2, NOW(), $3, $4)";
					$stmt = $sql->sql_secure($query, array($username, $_REQUEST['del'], $d[0]['s'], $d[0]['category']));
					if (isset($_REQUEST['debug'])) echo "$query;<br>\n".$sql->sql_error()."<br>\n";
				}
				$query = "DELETE FROM screen WHERE username=$1 AND title=$2";
				$stmt = $sql->sql_secure($query, array($username, $_REQUEST['del']));
				if (isset($_REQUEST['debug'])) echo "$query;<br>\n".$sql->sql_error()."<br>\n";
				$err = $sql->sql_error();
				die(($err? "&nbsp;Error: $err": "&nbsp;screen {$_REQUEST['del']} has been delated")."<br><br>\n&nbsp;<a href='./editor.php?s'>Continue</a><br><br>\n");
			}
		}
		if (!empty($_REQUEST['append'])) {
			emit_header();
			$f = starter_append($_REQUEST['append']);
			echo "result: $f<br><br><br>\n&nbsp;<a href='./editor.php?s'>Continue</a><br><br>\n";
		}
		if (isset($_REQUEST['new'])) {
			emit_header();
			if (isset($_REQUEST['s'])) {
				$data = $sql->sql_secure("SELECT COUNT(*) AS n FROM screen WHERE username=$1 AND title=$2", array($username, $_REQUEST['name']));
				if ($data[0]['n']>0) die("Error: screen {$_REQUEST['name']} already exists.<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
				if (GITLAB_API) {
					$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
					$resp = gitlab_post('create', 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['name'], $default);
				}
				$query = "INSERT INTO screen (created_on, last_update, s, username, title, ip) VALUES ('$now', '$now', $1, $2, $3, '{$_SERVER['REMOTE_ADDR']}')";
				$stmt = $sql->sql_secure($query, array($default, $username, $_REQUEST['name']));
				$err = $sql->sql_error();
				die(($err? "Error: $err": "New screen {$_REQUEST['name']} created")."<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
			}
			$dest = "./spa/usr/$username/{$_REQUEST['name']}.html";
			if (file_exists($dest)) die("Error: screen {$_REQUEST['name']} already exists.<br><br>\n<a href='./editor.php'>Continue</a><br><br>\n");
			file_put_contents($dest, $default);
		}
		if (empty($_REQUEST['open_editor'])) {
			emit_header();
			if (isset($_REQUEST['s'])) {
				if (!empty($_REQUEST['clone'])) {
					$data = $sql->sql_secure("SELECT * FROM screen WHERE username=$1 AND title=$2", array($_REQUEST['user'], $_REQUEST['clone']));
					if (empty($data)) {
						echo "Error, ".$sql->sql_error()."<br>\n";
					}
					else {
						if (GITLAB_API) {
							$udata = $sql->sql_secure("SELECT user_id FROM usercategory WHERE username=$1", array($username));
							$resp = gitlab_post('create', 'screens/user'.$udata[0]['user_id'].'/'.$_REQUEST['clone'], $data[0]['s']);
						}
						// echo "<pre>"; print_r($data); echo "</pre>\n";
						$query = "INSERT INTO screen (created_on, last_update, s, username, title, ip, category) VALUES ('$now', '$now', $1, $2, $3, '{$_SERVER['REMOTE_ADDR']}', $4)";
						$stmt = $sql->sql_secure($query, array($data[0]['s'], $username, $_REQUEST['clone'], $data[0]['category']));
						$err = $sql->sql_error();
						die(($err? "Error: $err": "New screen {$_REQUEST['name']} created")."<br><br>\n<a href='./editor.php?s'>Continue</a><br><br>\n");
					}
				}
				$cat = $sql->sql_secure("SELECT * FROM screencategory LIMIT 100", array());
				$coption = "<select onChange='myUpdate()' id='category' style='margin-bottom: 5px;'>\n<option value='*'>any group</option>\n";
				$category = array();
				$cid = 0;
				foreach ($cat as $c) {
					$category[$c['id']] = $c['description'];
					$selected = '';
					if ($c['description']==$_REQUEST['category']) {$selected = ' selected'; $cid = $c['id'];}
					$coption .= "<option value='{$c['description']}'$selected>{$c['description']}</option>\n";
				}
				$coption .= "</select>\n";
				$group = in_array($username, $admin)? "<a href='./group.php?admin'>groups</a>": 'group';
				$orderby = (!empty($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array('category', 'category DESC','username', 'username DESC','title','title DESC','last_update','last_update DESC','length','length DESC')))? $_REQUEST['orderby']: 'title';
				$userdata = $sql->sql_secure("SELECT DISTINCT username FROM screen WHERE NOT s IS NULL ORDER BY username", array());
				$limit = empty($_REQUEST['limit'])? 100: $_REQUEST['limit']-0;
				$title = empty($_REQUEST['title'])? '*': $_REQUEST['title'];
				$user = empty($_REQUEST['user'])? '*': $_REQUEST['user'];
				$query_param = array($user);
				$titlecond = '';
				if ($title!='*') {$query_param[] = strtr($title, array('*'=>'%')); $titlecond = " AND title LIKE $2";}
				$uoption = "<select onChange='myUpdate()' id='user' style='margin-bottom: 5px;'>\n<option value='*'>any username</option>\n";
				foreach ($userdata as $u) {
					$selected = $u['username']==$user? ' selected': '';
					$uoption .= "<option value='{$u['username']}'$selected>{$u['username']}</option>\n";
				}
				$uoption .= "</select>\n";
				$ucond = ($user=='*')? "'*'": 'username'; 
				$ccond = ($cid==0)? '': " AND $cid = ANY (category)";
				$query = "SELECT id,username,title,last_update,category,LENGTH(s) AS length, (CASE WHEN s LIKE '%<svg%' THEN 'Y' ELSE 'N' END) AS svg FROM screen WHERE $ucond=$1$ccond$titlecond AND NOT s IS NULL ORDER BY $orderby LIMIT $limit";
				$data = $sql->sql_secure($query, $query_param);
				if (isset($_REQUEST['debug'])) {echo $sql->sql_error()."$query;<br><pre>"; print_r($data); echo " $user</pre>";}
				echo "<style>.opengr {cursor: pointer; color: darkgreen;}</style>\n<form method='post' action='./editor.php?s'>
				<script>
					var win;
					function openGroup(id, name) {
						win = window.open('./group.php?screenid='+id+'&name='+name,name+' group','width=400,height=800');
					}
					function myClose() {
						win.close();
						document.location = './editor.php?s';
					}
					function myUpdate() {
						var user = 'user='+document.getElementById('user').value;
						var category = 'category='+document.getElementById('category').value;
						var limit = 'limit='+document.getElementById('limit').value;
						var title = 'title='+document.getElementById('title').value;
						document.location = './editor.php?s&'+user+'&'+category+'&'+limit+'&'+title;
					}
				</script>
				&nbsp;&nbsp;new screen <input type='text' name='name' id='name'>\n<input type='submit' name='new' value='create'>\n</form><table style='max-wdth: 500px; margin-left: 10px;'>";
				if (empty($data)) echo 'No screen available, please create your first screen now<br><br>';
				else echo "<tr>\n<td>&nbsp;$coption&nbsp;</td><td>&nbsp;</td><td>&nbsp;limit <input size='2' id='limit' value='$limit'>&nbsp;<img onClick='myUpdate()' style='cursor: pointer;' src='./img/zoom.png'>&nbsp;</td><td>&nbsp;$uoption&nbsp;</td><td>&nbsp;</td><td></td><td></td><td></td><td></td><td>&nbsp;<input id='title' value='$title'>&nbsp;<img onClick='myUpdate()' style='cursor: pointer;' src='./img/zoom.png'></td></tr>
					<tr style='background-color: #e0ffe0;'>
					<td>&nbsp;<a href='?s&orderby=category' style='font-weight: bold;color:orange;'>&lt;</a>$group<a href='?s&orderby=category DESC' style='font-weight: bold;color:orange;'>&gt;</a>&nbsp;</td>
					<td align='right'>&nbsp;<a href='?s&orderby=length' style='font-weight: bold;color:orange;'>&lt;</a>size<a href='?s&orderby=length DESC' style='font-weight: bold;color:orange;'>&gt;</a>&nbsp;</td>
					<td>&nbsp;<a href='?s&orderby=last_update' style='font-weight: bold;color:orange;'>&lt;</a>last update<a href='?s&orderby=last_update DESC' style='font-weight: bold;color:orange;'>&gt;</a>&nbsp;</td>
					<td align='right'>&nbsp;<a href='?s&orderby=username' style='font-weight: bold;color:orange;'>&lt;</a>username<a href='?s&orderby=username DESC' style='font-weight: bold;color:orange;'>&gt;</a>&nbsp;</td>
					<td colspan='5'>&nbsp;</td>
					<td>&nbsp;&nbsp;&nbsp;<a href='?s&orderby=title' style='font-weight: bold;color:orange;'>&lt;</a>title<a href='?s&orderby=title DESC' style='font-weight: bold;color:orange;'>&gt;</a></td></tr>\n";
				foreach ($data as $f) {
					$owner = $f['username'];
					$name = strtr($f['title'], array('.html'=>''));
					$cat = ''; $catarray = array();
					if (!empty($f['category'])) {
						$c = explode(',', trim($f['category'], '{}'));
						foreach($c as $ci) { $catarray[] = $category[$ci];}
						$cat = $category[$c[0]].(count($c)>1? "<span title='".implode(',', $catarray)."'>...</span>": '');
					}
					if (empty($cat)) $cat = '[none]';
					$del = $owner!=$username? "<td>&nbsp;&nbsp;&nbsp;<img src='./lib/clone.png' title='clone' style='cursor: pointer;' onClick=\"document.location = './editor.php?clone=$name$s&user=$owner'\"></td>\n": 
						"<td>&nbsp;&nbsp;&nbsp;<img src='./lib/delete.gif' title='remove' style='cursor: pointer;' onClick=\"document.location = './editor.php?remove=$name$s'\"></td>\n";
					$mv = $owner!=$username? "<td>&nbsp;</td>\n": "<td>&nbsp;<img src='./lib/mv.gif' title='rename/copy' style='cursor: pointer;' onClick=\"document.location = './editor.php?mv=$name$s'\"></td>\n";
					$precision = isset($_REQUEST['precision'])? $_REQUEST['precision']-0: 10;
					$uri = explode('?', $_SERVER["REQUEST_URI"]);
					$self = $_SERVER["SERVER_NAME"].$uri[0];
					$svg = $owner!=$username || $f['svg']=='N'? "<td>&nbsp;</td>\n": "<td>&nbsp;&nbsp;<img src='./img/SVG-edit.png' title='edit SVG' style='cursor: pointer; height: 20px;' onClick=\"document.location = '/lib/svgedit/?showGrid=true&precision=$precision&open=https://$self?svg={$f['id']}'\"> </td>\n";
					$edit = $owner!=$username? "<td>&nbsp;</td>\n<td>&nbsp;&nbsp; $name </td>\n": "<td>&nbsp;&nbsp;<img src='./lib/edit.gif' title='edit text without preview' style='cursor: pointer;' onClick=\"document.location = './editor.php?nopreview$s&open_editor=$name&id={$f['id']}'\"> </td>
						<td>&nbsp;&nbsp;&nbsp;<a  title='edit text with preview' href='./editor.php?s&open_editor=$name&id={$f['id']}'>$name </a> </td>\n";
					echo "<tr>
						<td>&nbsp;<span onClick='openGroup({$f['id']},\"$name\")' class='opengr'>$cat</span>&nbsp;</td><td align='right'>&nbsp;{$f['length']}&nbsp;</td><td>&nbsp;{$f['last_update']}&nbsp;</td><td align='right'>&nbsp;{$f['username']}&nbsp;</td>
						$del
						$mv
						<td>&nbsp;<img src='./lib/tree.png' title='append to starter tree' style='cursor: pointer;' onClick=\"document.location = './editor.php?append=$name$s'\"></td>
						$svg
						$edit
						</tr>\n";
				}
				die("</table></div>");
			}
			$files = array_diff(scandir("./spa/usr/$username"), array('.', '..', '.gitkeep', 'auth.php'));
			echo "<br><br><div style='margin-left: 10px;'><form method='post' action='./editor.php'>\n New screen name <input type='text' name='name' id='name'>\n<input type='submit' name='new' value='create'>\n</form><br><br>\n";
			if (empty($files)) {die("No screen available, please create your first screen now<br><br>");}
			echo "Screens<table style='max-wdth: 500px;'>";
			foreach ($files as $f) {
				$name = strtr($f, array('.html'=>''));
				echo "<tr>
					<td align='right'><a href='./editor.php?open_editor=$f' title=' edit this file'>$name </a> </td>
					<td>&nbsp;&nbsp;&nbsp;<img src='./lib/tree.png' title='append to starter tree' style='cursor: pointer;' onClick=\"document.location = './editor.php?append=$name'\"></td>
					<td>&nbsp;&nbsp;&nbsp;<img src='./lib/mv.gif' title='rename/copy' style='cursor: pointer;' onClick=\"document.location = './editor.php?mv=$name'\"></td>
					<td>&nbsp;&nbsp;&nbsp;<img src='./lib/delete.gif' title='remove' style='cursor: pointer;' onClick=\"document.location = './editor.php?remove=$name'\"></td>
					</tr>\n";
			}
			die("</table></div>");
		}
		$dest = "./spa/usr/$username/".$_REQUEST['open_editor'];
		$name = strtr($_REQUEST['open_editor'], array('.html'=>''));
		// echo "dest: $dest<br>\n";
		emit_editor($dest, $name);
	}
?>
