<?php
	if (!empty($_REQUEST['talk'])) {
		readfile('talk.html');
		exit();
	}
	require_once('./conf/conf.php');
	$context = stream_context_create(array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
	$yy = date('Y');

	function check_seed() {
		$s = file_get_contents(LFILE.$_REQUEST['host'].'_seed');
		if (isset($_REQUEST['debug'])) echo LFILE.$_REQUEST['host'].'_seed'."<br>$s<br>".($_REQUEST['seed']-0)."\n";
		if ($s != $_REQUEST['seed']-0) {
			header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			exit();
		}
	}
	if (isset($_REQUEST['state'])) {
		die(file_get_contents('http://pwma.elettra.eu/knob/index.php?cmd=status&ws='.$_REQUEST['host']));
	}
	if (isset($_REQUEST['acquire'])) {
		$a = file_put_contents(TMPFILE.$_REQUEST['host'].'_acquisition', $_REQUEST['acquire']);
		die('OK');
	}
	if (isset($_REQUEST['getacquisition'])) {
		if ($_REQUEST['getacquisition']=='full') {
			file_put_contents(TMPFILE.$_REQUEST['host'].'_acquisition', 'n.a.');
			file_put_contents(TMPFILE.$_REQUEST['host'], 'acquire');
			sleep(2);
		}
		$a = file(TMPFILE.$_REQUEST['host'].'_acquisition');
		$i = 20;
		while ($a[0] == 'n.a.' && $i>0) {
			// echo "."; flush();
			$a = file(TMPFILE.$_REQUEST['host'].'_acquisition');
			sleep(1);
			$i--;
		}
		$proc = array();
		$pre = array();
		foreach ($a as $m) {
			// https://stackoverflow.com/questions/22192324/replace-multiple-spaces-in-a-string-with-a-single-space
			$l = preg_replace("/ {2,}/", " ", $m);
			if (strpos($l,'0x')===false) {
				$b = explode(' ', $l);
				$proc[$b[1]] = $l;
			}
			if (strpos($l,'0x')===0 && strpos($l,'Desktop')===false && strpos($l,'xfce')===false && strpos($l,'Desktop')===false && strpos($l,'Firefox')===false && strpos($l,'Terminal')===false && strpos($l,'Browser')===false) {
				// echo "$l<br>\n";
				$wc = explode(' ',$l);
				if (isset($proc[$wc[2]])) {
					$pr = trim(implode(' ', array_slice(explode(' ',$proc[$wc[2]]),7)));
					if (strpos($pr, '-title')!==false) {
						$title = trim(implode(' ', array_slice($wc, 8)));
						// echo "title: $title<br>\n";
						$pr = strtr($pr, array($title => "&amp;quot;$title&amp;quot;"));
					}
					$pre[] = "		{\"exename\": \"$pr\", \"x\": {$wc[3]}, \"y\": {$wc[4]}}";
					//echo "{$wc[3]},{$wc[4]} - {$pr}<br>\n";
				}
				else echo "$l<br>\n";
			}
		}
		$img = $_REQUEST['img'];
		die("<textarea style='width:100%; height:150px;'>\n".'	{"[unique id]": {"label": "[label]", "description": "[description]", "facility": "fermi", "workstation": "[ws]", "cmd": ['."\n".implode(",\n", $pre)."\n	]}}\n</textarea><img style='width:100%;' src='https://pwma.elettra.eu/knob/$img'>");
	}
	if (isset($_REQUEST['request'])) {
		$h = explode('.', gethostbyaddr($_SERVER['REMOTE_ADDR']));
		$host = $h[0];
		if (isset($_REQUEST['debug']) && !empty($_REQUEST['host'])) $host = $_REQUEST['host'];
		if (isset($_REQUEST['debug']) && empty($_REQUEST['host'])) $host = 'do';
		if (strpos($host,'pcl-elettra-cr')===false && !in_array($host, $fermihosts) && strpos($host,'gaia')===false && !isset($_REQUEST['debug']))
			die("<html>\n<head>\n<meta http-equiv='refresh' content='4; url=https://puma-01.elettra.eu/knob/index.php'></head>\n<body>ERROR<br>not recognized host $host</body></html>"); 
		if (substr_count($_REQUEST['src'],'/')<2 || (substr_count($_REQUEST['src'],'/')==2 && strpos($_REQUEST['src'],'->')===false)) 
			die("<html>\n<head>\n<meta http-equiv='refresh' content='4; url=https://puma-01.elettra.eu/knob/index.php'></head>\n<body>ERROR<br>not recognized {$_REQUEST['src']}</body></html>"); 
		if (strpos($_REQUEST['src'],':')===false) {
			foreach ($in as $k=>$v) {
				$found = false;
				foreach ($v as $n) {
					$pos = strpos($_REQUEST['src'], $n);
					if ($pos !== false && $pos < 2) {
						$_REQUEST['src'] = $domains[$k].'/'.ltrim($_REQUEST['src'], '/');
						$found = true;
						break;
					}
				}
				if ($found) break;
			}
		}	
		$a = file_put_contents(LFILE.$host, $_REQUEST['src']);
		file_put_contents(LOGWFILE.$yy.'.log', date('Y-m-d H:i:s')." $host {$_REQUEST['src']}\n", FILE_APPEND | LOCK_EX);
		echo "<html>\n<head>\n<meta http-equiv='refresh' content='4; url=https://puma-01.elettra.eu/knob/tabletwheel.html?host=$host'></head>\n<body>OK<br>registered: {$_REQUEST['src']}<br> from host:$host</body></html>"; 
	}
	else if (isset($_REQUEST['debughost'])) {
		echo gethostbyaddr($_SERVER['REMOTE_ADDR'])."<br>\n";
		$s = file_get_contents(LFILE.$_REQUEST['host'].'_seed');
		die($s);
	}
	else if (isset($_REQUEST['service'])) {
		sleep(1);
		if (!empty($_REQUEST['conf'])) {
			$file = file_get_contents('./conf/knob.json');
			if (empty($file) || time() - filemtime('./conf/knob.json') > 86400*7) {
				$file = file_get_contents('https://gitlab.elettra.eu/puma/client/web/-/raw/master/knob/conf/knob.json', false, $context);
				if (!empty($file) && $file{0} === '{') file_put_contents('./conf/knob.json', $file);
			}
			// $f = json_decode(file_get_contents('./conf/knob.json'), true);
			$f = json_decode($file, true);
			if (isset($_REQUEST['debug'])) {echo "<pre>"; print_r($f);echo "</pre>"; }
			$cmd = $f[$_REQUEST['conf']]['cmd'];
			if (empty($cmd)) exit();
			$res = array();
			foreach ($cmd as $l) {
				if (isset($l['src'])) {
					$src = trim($l['src']);
				}
				else $src = trim($l);
				if (empty($src)) continue;
				$s = isset($l['readsrc'])? $l['readsrc']: $src;
				$c = json_decode(file_get_contents("http://puma-01.elettra.eu/rchan.php?json&src=$s&property"), true);
				$conf = $c[0];
				$val = sprintf('%6.2f', $conf['value']-0)-0;
				$param = array('src'=>$src, 'val'=>$val);
				if (isset($conf['max'])) $param['max'] = $conf['max']-0;
				if (isset($conf['min'])) $param['min'] = $conf['min']-0;
				if (isset($conf['writable'])) $param['writable'] = $conf['writable']-0;
				if (isset($l['throttlingPeriod'])) $param['throttlingPeriod'] = $l['throttlingPeriod'];
				if (isset($l['chart'])) $param['chart'] = $l['chart'];
				if (isset($l['state'])) $param['state'] = $l['state'];
				if (isset($l['readsrc'])) $param['readsrc'] = $l['readsrc'];
				$res[] = $param;
			}
		}
		else {
			check_seed();
			$file = file(LFILE.$_REQUEST['host']);
			$t = time();
			while (empty($file) && time()-$t < 3600) {
				sleep(3);
				$file = file(LFILE.$_REQUEST['host']);
				check_seed();
			}
			check_seed();
			if (empty($file)) exit();
			$res = array();
			foreach ($file as $l) {
				$g = explode(',', trim($l));
				$f = trim($g[0]);
				if (empty($f)) continue;
				$c = json_decode(file_get_contents("http://puma-01.elettra.eu/rchan.php?json&src=$f&property"), true);
				$conf = $c[0];
				$val = sprintf('%6.2f', $conf['value']-0)-0;
				$param = array('src'=>$f, 'val'=>$val);
				if (isset($conf['max'])) $param['max'] = is_numeric($conf['max'])? $conf['max']-0: $conf['max'];
				if (isset($conf['min'])) $param['min'] = is_numeric($conf['min'])? $conf['min']-0: $conf['min'];
				if (isset($conf['writable'])) $param['writable'] = $conf['writable']-0;
				foreach ($g as $i=>$c) {
					if ($i == 0) continue;
					if (strpos($c, 'chart')!==false) $param['chart'] = true;
					if (strpos($c, 'state')!==false) $param['state'] = 'State';
					if (strpos($c, 'throttlingPeriod')!==false) {$p = explode('=', $c); $param['throttlingPeriod'] = $p[1]-0;}
				}
				$res[] = $param;
			}
		}
		if (!empty($res)) echo json_encode($res);
		if ($param['writable']>0) {
			file_put_contents(LFILE.$_REQUEST['host'], '');
		}
		file_put_contents(LOGWFILE.$yy.'.log', date('Y-m-d H:i:s')." {$_REQUEST['host']}: ".json_encode($res)."\n", FILE_APPEND | LOCK_EX);
	}
	else if (!empty($_REQUEST['seed'])) {
		$a = file_put_contents(LFILE.$_REQUEST['host'].'_seed', $_REQUEST['seed']);
		file_put_contents(LOGWFILE.$yy.'.log', date('Y-m-d H:i:s')." seed={$_REQUEST['seed']}\n", FILE_APPEND | LOCK_EX);
	}
	else {
		$emergency = '';
		$emef= file_get_contents(TMPFILE."emergency");
		if (!empty($emef) && strpos($emef,'stop')!==false) {
			$emergency = '&emergency';
		}
		$h = explode('.', gethostbyaddr($_SERVER['REMOTE_ADDR']));
		$host = $h[0];
		if ((strpos($host,'pcl-elettra-cr')!==false || in_array($host, $fermihosts) || strpos($host,'gaia')!==false) && !isset($_REQUEST['debug'])) {
			$html = file_get_contents('./cmdlist.html');
			$h = strtr($host, array('pcl-elettra-cre-0'=>'ee','pcl-elettra-crf-0'=>'ef'));
			$content = "<div style='margin: 10px;'><h2>Knob usage</h2>\n<ol>
				<li>Connect TABLET or MOBILE device to control network.</li>
				<li>Open <span style='font-size:130%; font-weight: bold; color:red;'>https://puma-01.elettra.eu/knob</span> on TABLET or MOBILE device.</li>
				<li>Select Workstation $host on TABLET or MOBILE device.</li>
				<li>Go back to workstation $host, drag a read/write attribute from a panel and drop it on the pop-up.</li>
				</ol></div><br><br>
				<h2>&nbsp;Talk through mobile<br><img src='./img/qrcode_$h.png' style='max-height: 600px;'></h2>"; 
			$replace = array(
				'wLauncher'=>'Knob / wLauncher',
				'<!--list-->' => "$content<script>\nwindow.open('https://puma-01.elettra.eu/knob/launcher.php?cmdlist&tabletwheel&host=$host$emergency',null,'width=370px,height=600px,location=no,toolbar=no,menubar=no,scrollbar=yes');\n</script>\n"
			);
			die(strtr($html, $replace));
		}
		else {
			$html = file_get_contents('./connectws.html');
			$f = json_decode(file_get_contents('./conf/knob.json'), true);
			if (empty($f)) die($html);
			if (isset($_REQUEST['debug'])) {echo "<pre>"; print_r($f); print_r($_REQUEST); echo "</pre>"; }
			$fermiconf = $elettraconf = array();
			foreach ($f as $k=>$l) {
				if ($l['facility'] == 'fermi') $fermiconf[] = "<input type='radio' name='fermiconf' value='$k'> <a href='./index.php?host={$l['workstation']}&conf=$k'>{$l['label']} ({$l['workstation']})</a><br>";
				else if ($l['facility'] == 'elettra') $elettraconf[] = "<option value='$k'>$k</option>";
			}
			$replace = array(
				'<!--fermiconf-->' => (empty($fermiconf)? '': "<div style='margin-top: 5px;'>Configurations</div>\n".implode("\n",$fermiconf)."<br>\n"),
				'<!--elettraconf-->' => (empty($elettraconf)? '': "Configurations<br>\n<select id='elettraconf'>\n<option value=''> </option>\n".implode("\n",$elettraconf)."</select>\n"),
				'<!--emergency-->' => (empty($emergency)? 'false': 'true')
			);
			die(strtr($html, $replace));
		}
	}

?>
