<?php
	$host = explode('.', $_SERVER["HTTP_HOST"]);
	$method = empty($_REQUEST['method'])? 'read': $_REQUEST['method'];
	if (!isset($_SERVER["HTTPS"]) || ($_SERVER["HTTPS"]!=="on") || !isset($host[2]) || ($host[2]!=="eu")) {
		header("Location: https://{$host[0]}.elettra.eu".$_SERVER["REQUEST_URI"]);
		die();
	}
	$yy = date('Y');
	$domains = array(
		'ELETTRA'   => "srv-tango-sre-01.ecs.elettra.trieste.it:20000",
		'bl014' => "bl014-control-01.blcs.elettra.trieste.it:20000",
		'bl024' => "bl024-control-01.blcs.elettra.trieste.it:20000",
		'bl034' => "bl034-control-01.blcs.elettra.trieste.it:20000",
		'FERMI'     => "srv-tango-srf-01.fcs.elettra.trieste.it:20000",
		'PADReS'    => "srv-tango-padres-01.fcs.elettra.trieste.it:20000",
		'TIMER'     => "srv-tango-tmr-01.fcs.elettra.trieste.it:20000",
		'TIMEX'     => "srv-tango-tmx-01.fcs.elettra.trieste.it:20000",
		'LDM'       => "srv-tango-ldm-01.fcs.elettra.trieste.it:20000",
		'DiProI'    => "srv-tango-dpi-01.fcs.elettra.trieste.it:20000",
		'Magnedyn'  => "srv-tango-mag-01.fcs.elettra.trieste.it:20000",
		'TeraFERMI' => "srv-tango-tf-01.fcs.elettra.trieste.it:20000",
		'Infrastructures' => "infra-control-01.elettra.trieste.it:20000",
		'dev' => "srv-tango-ctrl-01:20000"
	);

	require_once("../conf.php");
	function rchan($src) {
		global $method;
		$port = 8443; // 9293;
		$keys = $port == 8443? '"keys":["src","method","options"],': '';
		$url = "https://{$_SERVER['SERVER_NAME']}:$port/bu/src-bundle";
		$isProp = strpos($src, '#')!==false;
		$payload = '{'.($isProp? '': '"channel":"rchan",').'"srcs":[{'.$keys.'"method":"'.$method.'","options":["p"],"src":"'.$src.'"}],"type":"srcs"}'; // \r\n\r\n
		if (isset($_REQUEST['debug'])) die("$url<br>$payload");
		$ch = curl_init($url);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $payload );
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(
			'Content-Type: application/json',
			'Content-Length: ' . strlen($payload))
		);
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;
	}

	function eval_formula() {
		$sql = open_db();
		if ($_REQUEST["key"] == 'https://pwma-dev.elettra.eu:10443/v1/formula') {
			$data = $sql->sql_select("DISTINCT username AS label, username AS formula", "formula", "dateexpiration > NOW() IS NOT FALSE");
			$branch = true;
		}
		else {
			$stmt = $sql->sql_prepare("SELECT label, formula FROM formula WHERE username=$1 AND dateexpiration>NOW() IS NOT FALSE", "q1");
			list($trash, $username) = explode('/formula/', $_REQUEST['key'], 2);
			$data = $sql->sql_execute(array($username), "q1");
			$branch = false;
		}
		$output = array();
		foreach ($data as $d) {
			$output[] = array('title'=>$d['label'], 'key'=>$_REQUEST['key'].'/'.$d['label'], "lazy"=>$branch, "folder"=>$branch);
		}
		header("Content-Type: application/json");
		file_put_contents("tree_$yy.log", json_encode($_REQUEST).' - '.json_encode($output)."\n", FILE_APPEND);
		die(json_encode($output));
	}

	function multiexplode ($delimiters,$string) {
		$ready = str_replace($delimiters, $delimiters[0], $string);
		$launch = explode($delimiters[0], $ready);
		return  $launch;
	}

	if (isset($_REQUEST["formula"])) {
		$sql = open_db();
		$stmt = $sql->sql_prepare("SELECT formula FROM formula WHERE label=$1", "q1");
		$data = $sql->sql_execute(array($_REQUEST["formula"]), "q1");
		$formulaArray = explode('tango://', $data[0]['formula']);
		foreach ($formulaArray as $k=>$f) {
			if ($k==0) continue;
			$t = explode('/', $f);
			$e = multiexplode(array(' ','<','>','+','-','+','*','|','&'),$t[4]);
			$t[4] = strtr($t[4], array($e[0]=>$e[0].'"'));
			$formulaArray[$k] = implode('/', $t);
		}
		$formula = implode('"tango://',$formulaArray);	
		header("Content-Type: application/json");
		die(json_encode($formula));
	}

	$output = array();
	if (isset($_REQUEST["search"])) {
		$url = strip_tags($_REQUEST["search"]);
	}
	else if (isset($_REQUEST["key"])) {
		if (strpos($_REQUEST["key"],'tango://')===false && strpos($_REQUEST["key"],'formula')!==false) {
			eval_formula();
		}
		$url = ''.strip_tags(trim($_REQUEST["key"],'/*')).'/*';
	}
	else {
		$i = 0;
		// $output[] = array('title'=>'<span style="color:red;">formula</span>', 'key'=>'formula', "lazy"=>true, "folder"=>true);
		foreach ($domains as $key=>$val) {
			$url = $val;
			$i++;
			$output[] = array('title'=>"<span id='n$i' class='speech $key'>$i</span>&nbsp;&nbsp;$key", 'key'=>strtr($url, array('*'=>'')), "lazy"=>true, "folder"=>true);
		}
		header("Content-Type: application/json");
		file_put_contents("tree_$yy.log", json_encode($_REQUEST).' - '.json_encode($output)."\n", FILE_APPEND);
		die(json_encode($output));		
	}
	$substr_count = substr_count($url, '/');
	$branch = $substr_count < 4;
	file_put_contents("tree_$yy.log", date('Y-m-d H:i:s ').json_encode($_REQUEST).', url: '.$url.", substr_count(): $substr_count\r\n", FILE_APPEND);
	$context = stream_context_create(array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
	try {
		if (isset($_REQUEST['debug'])) {echo "<pre>";print_r($url);echo "</pre>\n";}
		if (!$branch) {
			$url = trim($url,'/*');
			$content = file_get_contents('https://puma-01.elettra.eu/rchan.php?src='.$url.'/&json&valueOnly', false, $context);
			$cmd = file_get_contents('https://puma-01.elettra.eu/rchan.php?src='.$url.'->&json&valueOnly', false, $context);
			$props = file_get_contents('https://puma-01.elettra.eu/rchan.php?src='.$url.'(*)&json&valueOnly', false, $context);
		}
		else {
			if (isset($_REQUEST['debug'])) {echo 'https://puma-01.elettra.eu/rchan.php?src='.$url.'&json&valueOnly -- ';}
			$content = file_get_contents('https://puma-01.elettra.eu/rchan.php?src='.$url.'&json&valueOnly', false, $context);
		}
		if (isset($_REQUEST['debug'])) {echo "<br>content: $content<br>\n";}

		if ($content === false) {
			if (isset($_REQUEST['debug'])) {echo "<br>content === false\n";}
		}
	} catch (Exception $e) {
		if (isset($_REQUEST['debug'])) {echo "ERROR $e\n";}
	}
	if (isset($_REQUEST["search"])) {
		header("Content-Type: application/json");
		echo curl_exec($ch);
		curl_close($ch);
		exit();
	}
	// $output contains the output string
	$input = json_decode($content);
	if (is_array($input[0])) $input = $input[0];
	$level = substr($_REQUEST[n], 0, 20);

	if (isset($_REQUEST['debug'])) {echo "<pre>";print_r($input);echo "</pre>\n";}
	if (!$branch) {
		$j = 0;
		foreach ($input as $i) {
			$j++;
			// $egigaLink = " <a href='http://ecsproxy.elettra.eu/docs/egiga2m/lib/service/redirect_service.php?conf=$conf&start=last 24 hours&s=$search' target='_blank'><img src='https://pwma.elettra.eu/egiga2m/img/multi.png' title='Check last 24 hours logs on eGiga2m'></a>";
			$sub['attributes'][] = array('title'=>"<span id='{$level}_$j' class='speech $level $i'>$j</span>&nbsp;&nbsp;$i", 'key'=>$url.'/'.$i, "lazy"=>$branch, "folder"=>$branch);
		}
		foreach (json_decode($cmd) as $i) {
			$j++;
			$sub['commands'][] = array('title'=>"<span id='{$level}_$j' class='speech $level $i'>$j</span>&nbsp;&nbsp;$i", 'key'=>strtr($url, array('->'=>'')).'->'.$i, "lazy"=>$branch, "folder"=>$branch);
		}
		foreach (json_decode($props) as $i) {
			$j++;
			$sub['properties'][] = array('title'=>"<span id='{$level}_$j' class='speech $level $i'>$j</span>&nbsp;&nbsp;$i", 'key'=>strtr($url, array('(*)'=>'')).'('.$i.')', "lazy"=>$branch, "folder"=>$branch);
		}
		ksort($sub);
		foreach ($sub as $key=>$val) {
			$output[] = array('title'=>$key, 'key'=>strtr($url, array('*'=>'')).$key, "lazy"=>false, "folder"=>true, "children"=>$val, "expanded"=>true);
		}
	}
	else {
		$j = 0;
		foreach ($input as $i) {
			$j++;
			$output[] = array('title'=>"<span id='{$level}_$j' class='speech $level $i'>$j</span>&nbsp;&nbsp;$i", 'key'=>strtr($url, array('*'=>'')).$i, "lazy"=>$branch, "folder"=>$branch);
		}
	}
	header("Content-Type: application/json");
	echo json_encode($output);
	file_put_contents("tree_$yy.log", json_encode($_REQUEST).' - '.json_encode($output)."\n", FILE_APPEND);

?>
