<?php

	require_once("./conf.php");
	require_once("./auth.php");
	require_once("./uti.php");
	$username = '';
	$sql = open_db();

	// ----------------------------------------------------------------
	// check access credentials
	function check_access() {
		global $sql, $username, $timediff, $webtokenExpirationSeconds;
		$remote = $_SERVER['REMOTE_ADDR'];
		$forwarded = isset($_SERVER['HTTP_X_FORWARDED_FOR'])? $_SERVER['HTTP_X_FORWARDED_FOR']: 0;
		$yy = date('Y');
		if (isset($_SESSION['token'])) {
			$query = "SELECT * FROM userlog_$yy WHERE webtoken=$1 AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1";
			$stmt = $sql->sql_prepare($query, "q1");
			if (isset($_REQUEST['debug'])) echo "<br>$query; array({$_SESSION['token']})<br>\n";
			$data = $sql->sql_execute(array($_SESSION['token']), "q1");
			$username = $data[0]['username'];
			if (!empty($data)) {die('OK,'.$username);}
		}
		if (!empty($_REQUEST['username']) and isset($_REQUEST['puma_password'])) {
			$r = puma_auth($_REQUEST['username'], $_REQUEST['puma_password']);
			if ($r!="Login OK") die("login failed<br><br>");
			for ($i=0,$token=""; $i<5; $i++) {
				$token .= sprintf("%02x", rand(0, 256));
			}
			$_SESSION['token'] = $token;
			$query = "INSERT INTO userlog_$yy (date,webtoken,username,ip) VALUES (NOW(),$1,$2,$3)";
			$stmt = $sql->sql_prepare($query, "q2");
			if (isset($_REQUEST['debug'])) echo "<br>$query; array($token, {$_REQUEST['username']}, $remote)<br>\n";
			$data = $sql->sql_execute(array($token, $_REQUEST['username'], $remote), "q2");
			$username = $_REQUEST['username'];
			die('OK,'.$username);
		}
		die("NOK<br>\n".json_encode($_REQUEST));
	}

	// session_cache_expire(600);
	session_start();
	if (isset($_REQUEST['debug'])) {
		echo "\$_REQUEST: "; print_r($_REQUEST);
		echo "<br>\n<br>\n\$_COOKIE: "; print_r($_COOKIE);
		echo "<br>\n<br>\n\$_SESSION: "; print_r($_SESSION);
		echo "<br>\n<br>\n";
	}
	if (isset($_REQUEST['login'])) {
		die("IP: $remote<br><form method='post' action='?dir={$_REQUEST['dir']}'>username <input type='text' name='username'><br><br>password <input type='password' name='puma_password'> <input type='submit'></form><br /></body></html>\n");
	}

	if (isset($_REQUEST['logout'])) {
		unset($_SESSION['token']);
	}
	check_access();
	die('OK,'.$username);

?>
