var remember;

var networkStatus = "";
var fel=[false,false];
var $_GET = getQueryParams(document.location.search);

if (typeof localstorage != 'undefined' && localStorage.getItem("lastMode")==undefined) {
	localStorage.setItem("lastMode","");
	localStorage.setItem("astorMode","all");
}

// https://stackoverflow.com/questions/168963/stop-jquery-load-response-from-being-cached
$.ajaxSetup ({cache: false});

$(document).ready( function() {
	if(app) {
		document.addEventListener('deviceready', onDeviceReady);
	} else {
		onDeviceReady();
	}
});

function onDeviceReady() {
	console.log('onDeviceReady()', app, $_GET);
	if(app) {
		window.cache.clear( cacheClear, cacheNotClear );
		window.cache.cleartemp();
		$(window).on("online",onOnline);
		$(window).on("offline",onOffline);
		
		$("#fermiBtn").on("click", loadFERMI);
		$("#astorBtn").on("click", loadAstor);
		$("#astorPadresBtn").on("click", loadAstorPadres);
		$("#astorElettraBtn").on("click", loadAstorElettra);
		$("#endOfSBtn").on("click", function(e) {loadFullFrame(e);});
		$("#turniOpBtn").on("click", function(e) {loadFullFrame(e);});
		$("#turniPhBtn").on("click", function(e) {loadFullFrame(e);});
		// $("#elettraBtn").on("click", function(e) {loadFullFrame(e);});
		$("#scwStatus").on("click", function(e) {loadScwStatus(e);});
		$("#wsTest").on("click", function(e) {loadWsStatus(e);});
		$("#thresBtn").on("click", loadThresholds);
		loadLastMode();	
	} else {
		const protocol = window.location.protocol;
		// if (protocol=='http:') document.location = './cordova/index.html'+document.location.search;
		const url = './' + (typeof $_GET.screen === 'undefined'? $_GET.version +'.html' : 'react2cordova.php?screen='+$_GET.screen);
		const stitle = $_GET.screen? $_GET.screen: $_GET.version;
		console.log('onDeviceReady()', `../screens.php?logFileScreen=${stitle}.html`);
		fetch(`../screens.php?logFileScreen=${stitle}.html`);
		$("#navTitle").html($(document).width()>600? stitle: stitle.split('/').slice(-1)[0]);
		document.title = ($_GET.screen? $_GET.screen: $_GET.version) + ' PUMA';
		$("#mainPage").load(url, function() {
			adaptToWidth();
			$(document).ready( function() {
				if (typeof onScreenLoaded === "function") onScreenLoaded();
				initVar();
			});
		});			
	}
}
function loadLastMode(){
	switch (localStorage.getItem("lastMode")) {
			case "Astor":
				loadAstor();
				break;
			case "AstorPadres":
				loadAstor();
				break;
			case "AstorElettra":
				loadAstor();
				break;
			case "FERMI Status":
				loadFERMI();
				break;
			case "End of Shift":
				loadFullFrame("End of Shift");
				break;
			case "Turni Operatori":
				loadFullFrame("Turni Operatori");
				break;
			case "Turni Fisici":
				loadFullFrame("Turni Fisici");
				break;
			case "Elettra Status":
				loadFullFrame("Elettra Status");
				break;
		}
}

function loadFullFrame(e) {
	var title,source,btnId;
	if (typeof e!="string") {
		btnId=$(e.target).prop("id");
	} else {
		btnId=e;
	}
	switch (btnId) {
		case "elettraBtn":
			title="Elettra Status";
			source="http://elog.elettra.eu/informationsystem/web.asp";
			break;
		case "endOfSBtn":
			title="End of Shift FERMI";
			source="http://felog.elettra.eu/forum.asp?FORUM_ID=66";
			break;
		case "turniOpBtn":
			title="Turni Operatori";
			source="http://pwma-dev.elettra.eu/turni_operatori.php";
			break;
		case "turniPhBtn":
			title="Turni Fisici FERMI";
			source="http://pwma-dev.elettra.eu/turni_fisici.php";
			break;
	}
	if(app) {
		remember = document.forms["rememberMode"]["checkbox"].checked;
		if(remember){
			aggLastMode(title);
		} else {
			localStorage.setItem("lastMode","");
		}
	}
	
	$("#mainPage").load("fullFrameIndex.html", function(responseText,textStatus,jqXHR) {
		if(textStatus=="error") {
			$("#mainPage").html('<div class="media bg-info"> <div class="media-left media-middle"> <img src="img/icon.png" class="media-object" style="width:40px" /> </div> <div class="media-body media-middle"> <h4 class="text-center center-block media-heading" >Astor</h4></div></div><hr><div id="networkErr" class="container-fluid" style="display:none"><h4 class="text-danger text-center">Error: not possible to load the page</h4></div>');
		} else {
			$(document).ready( function() {
				if (app) {$(".media-left").html('<a onclick="localStorage.setItem(\'lastMode\',\'\')" href="index.html"> <img src="img/icon.png" class="media-object" style="width:40px" /></a>');}
				$("#pageTitle").html(title);
				$(".fullFrame").css("padding-bottom",$(window).height()-55);
				$("#fullframe").prop("src",source);
			});
		}
	});	
}

function aggLastMode(title) {
	localStorage.setItem("lastMode",title);
	navigator.notification.alert("Tap on Elettra-Sincrotrone logo to return to the mode selection page",null,"Default Mode: "+title);
}

function getQueryParams(qs) {
		qs = qs.split("+").join(" ");
		var params = {},
						tokens,
						re = /[?&]?([^=]+)=([^&]*)/g;
		while (tokens = re.exec(qs)) {
				params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
		}
		return params;
};

function onOnline() {
	if(networkStatus != "connected" && networkStatus != "") {
		networkStatus="connected";
		$("#networkErr").hide();
		navigator.notification.alert("Connessione alla rete ristabilita", null, "Online");
		$("#main").show();
	}
};

function onOffline() {
	if(networkStatus != "disconnected") {
		networkStatus="disconnected";
		$("#main").hide();
		navigator.notification.alert("Impossibile visualizzare i dati in modalità offline", null, "Offline");
		$("#networkErr").show();
	}
};

function cacheClear (status) {
	//alert('Message: ' + status);
};

function cacheNotClear (status) {
	navigator.notification.alert("Errore: "+status+"\nLa cache non è stata pulita correttamente, i grafici potrebbero essere datati.\nRiavviare l'applicazione", null, "Errore");
};
