<?php
	session_start();
	$username = '';
	require_once("./conf.php");
	require_once("./uti.php");
	if (isset($_SESSION['token'])) {
		$sql = open_db();
		$yy = date('Y');
		$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
		if (!empty($data)) {
			$un = explode('@', $data[0]['username']);
			$username = strtolower($un[0]);
		}
	}
	if (empty($username)) {
		emit_header();
		die("&nbsp;Page available only for authorized users. If you are authorized, please <a href='./'>login</a>.");
	}
	open_json();

	// ----------------------------------------------------------------
	// emit header
	function emit_header() {
		global $username, $local;
		echo "		<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>\n";
		echo '<nav class="navbar navbar-default">
	  <div class="container-fluid bg-info">
		<div class="navbar-header">
		  <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#myNavbar">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>                        
		  </button>
		  <a class="navbar-brand" href="./starter.php"><img src="/img/puma.svg" style="width:40px; height:40px; margin-top: -10px; margin-left: -5px; display: inline;"> 
		  <span style="font-size: 150%; font-weight: bolder; color: black">PUMA Editor
		  <!--h2 style="color: black">PUMA</h2--></span></a>
		  <ul style="float: right"><!--class="nav navbar-form navbar-right"-->
			 <div>';
		if (!empty($username)) {
			echo '
			  <form method="post" action="./starter.php" style="margin: 0px;">welcome '.$username.' <button type="submit" name="logout" class="btn btn-default">Logout</button></form>';
		}
		echo '
			<script>
				document.body.style.fontSize = "2em";
				if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/)!=null && window.innerWidth>600) {
					document.body.style.fontSize = "5em";
				}
			</script>
			 </div>
		  </ul>
		</div>
	  </div>
	</nav>';
	}

	// ----------------------------------------------------------------
	// emit json file editor dialog
	function open_json() {
		global $username, $local, $sql;
		if (isset($_REQUEST['save'])) {
			$now = date('Y-m-d H:i:s');
			$sdata = $sql->sql_secure("SELECT COUNT(*) AS n FROM starter WHERE username = $1", array($username));
			$query = "INSERT INTO starter (datemodified, screens, username) VALUES('$now', $1, $2)";
			if ($sdata && $sdata[0]['n']>0) $query = "UPDATE starter SET datemodified='$now', screens=$1 WHERE username=$2";
			$stmt = $sql->sql_secure($query, array($_REQUEST['edited_text'], $username));
			$err = ' '.strtr($sql->sql_error(), array("\n"=>' - '));
			// die(json_encode($_REQUEST));
			header("Location: ".$_SERVER['PHP_SELF']."?err=$err");
			exit();
		}
		$err = empty($_REQUEST['err'])? '': strip_tags($_REQUEST['err']);
		$sdata = $sql->sql_secure("SELECT screens FROM starter WHERE username = $1", array($username));
		$mode = "application/json\",\ngutters: [\"CodeMirror-lint-markers\"],\nlint: true,\ntrash:\"trash";
		// $contents = json_encode(json_decode($sdata[0]['screens']), JSON_PRETTY_PRINT);
		$contents = $sdata[0]['screens'];
		$text = "	<div style='display: flex; height: 96%'>
			<textarea style='min-width: 900px; width: 99%; max-height: 1200px; overflow-y: scroll' name='edited_text' id='edited_text'>".strtr($contents,array('&'=>'&amp;','<'=>'&lt;'))."</textarea>
			</div>\n	</div>\n	</div>";
		echo "<!DOCTYPE html>\n	<!--html lang='en'-->\n	<html>
		<head>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>
		<body style='padding:0;'>
		<form method='post' action='?save'>
		<div style='background-color: #d9edf7;'>&nbsp;
		<img src='/img/puma.svg' style='width:40px; height:40px; margin-top: 3px; margin-left: 3px; cursor: pointer;' onClick='document.location = \"./starter.php\"'>
		<b>TEXT STARTER EDITOR</b>&nbsp;&nbsp;
		<input type='submit' class='btn btn-primary' value='save' onClick=\"document.getElementById('top').value = editor.getScrollInfo().top\">&nbsp;&nbsp;
		<input type='submit' class='btn btn-primary' onclick=\"window.location='starter.php?tree_geditor'; return false;\" value='Graphic Starter Editor'>&nbsp;&nbsp;
		<input type='submit' class='btn btn-primary' onclick=\"window.location='starter.php'; return false;\" value='Exit'>
		$err
		<input type='hidden' id='top' name='top' value='0'></div>
		$text";
		emit_editor_js('starter', $mode, "'100%'");
		die('</form>'); // die('json_encode($sdata)');
	}

	// ----------------------------------------------------------------
	// emit file editor
	function emit_editor_js($document_title, $mode, $sizeX) {
		global $username, $local;
		$sizeY = '65';
		$top = isset($_REQUEST['top'])? $_REQUEST['top']: '0';
		$wrapping = 'lineWrapping: true,';
        if (!$local) {
        	echo "
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/codemirror.min.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/matchesonscrollbar.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/dialog/dialog.css'>
        		<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/lint.css'>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/codemirror.min.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/edit/matchbrackets.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/jump-to-line.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/matchesonscrollbar.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/searchcursor.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/search/search.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/scroll/annotatescrollbar.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/dialog/dialog.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/htmlmixed/htmlmixed.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/xml/xml.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/javascript/javascript.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/css/css.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/clike/clike.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/php/php.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/mode/sql/sql.js'></script>
        		<script src='https://unpkg.com/jshint@2.9.6/dist/jshint.js'></script>
        		<script src='https://unpkg.com/jsonlint@1.6.3/web/jsonlint.js'></script>
        		<script src='https://unpkg.com/csslint@1.0.5/dist/csslint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/javascript-lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/json-lint.js'></script>
        		<script src='https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.3/addon/lint/css-lint.js'></script>\n";
        }
        else {
        	echo "
        		<link rel='stylesheet' href='./lib/codemirror/lib/codemirror.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/search/matchesonscrollbar.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/dialog/dialog.css'>
        		<link rel='stylesheet' href='./lib/codemirror/addon/lint/lint.css'>
        		<script src='./lib/codemirror/lib/codemirror.js'></script>
        		<script src='./lib/codemirror/addon/edit/matchbrackets.js'></script>
        		<script src='./lib/codemirror/addon/search/jump-to-line.js'></script>
        		<script src='./lib/codemirror/addon/search/matchesonscrollbar.js'></script>
        		<script src='./lib/codemirror/addon/search/searchcursor.js'></script>
        		<script src='./lib/codemirror/addon/search/search.js'></script>
        		<script src='./lib/codemirror/addon/scroll/annotatescrollbar.js'></script>
        		<script src='./lib/codemirror/addon/dialog/dialog.js'></script>
        		<script src='./lib/codemirror/mode/htmlmixed/htmlmixed.js'></script>
        		<script src='./lib/codemirror/mode/xml/xml.js'></script>
        		<script src='./lib/codemirror/mode/javascript/javascript.js'></script>
        		<script src='./lib/codemirror/mode/css/css.js'></script>
        		<script src='./lib/codemirror/mode/clike/clike.js'></script>
        		<script src='./lib/codemirror/mode/php/php.js'></script>
        		<script src='./lib/codemirror/mode/sql/sql.js'></script>
        		<script src='https://unpkg.com/jshint@2.9.6/dist/jshint.js'></script>
        		<script src='https://unpkg.com/jsonlint@1.6.3/web/jsonlint.js'></script>
        		<script src='https://unpkg.com/csslint@1.0.5/dist/csslint.js'></script>
        		<script src='./lib/codemirror/addon/lint/lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/javascript-lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/json-lint.js'></script>
        		<script src='./lib/codemirror/addon/lint/css-lint.js'></script>\n";
        }
        echo "
        	<script>
        		var width = window.innerWidth
        			|| document.documentElement.clientWidth
        			|| document.body.clientWidth;
        		var height = window.innerHeight
        			|| document.documentElement.clientHeight
        			|| document.body.clientHeight;
        		var myTextarea = document.getElementById('edited_text');
        		var editor = CodeMirror.fromTextArea(myTextarea, {
        			lineNumbers: true,
        			$wrapping
        			matchBrackets: true,
        			mode: \"$mode\",
        			indentUnit: 4,
        			indentWithTabs: true,
        			extraKeys: {\"Alt-F\": \"findPersistent\"}
        		});
        		document.title = '$document_title';
        		editor.setSize($sizeX, height - $sizeY);
        		editor.scrollTo(null, $top);
        		</script>
        			<script type='text/javascript' src='./spa/js/conf.js'></script>
        			<script type='text/javascript' src='./spa/js/d3.v3.min.js'></script>
        			<script type='text/javascript' src='./spa/js/d3_gauge.js'></script>
        			<script type='text/javascript' src='./spa/js/puma.js'></script>
        			<script type='text/javascript'>initVar();$('.panel-collapse').removeClass('panel-collapse');$('.collapse').removeClass('collapse');</script>
        		</body>
		\n";
	}
?>
