<?php
	echo '<!doctype html>
	<html lang="en">
		<head>
			<title>workstation configuration</title>
			<meta charset="utf-8">
			<meta name="viewport" content="width=device-width, initial-scale=1">
			<link rel="stylesheet" href="https://puma-01.elettra.eu/lib/bootstrap4/bootstrap.min.css">
			<script src="https://puma-01.elettra.eu/lib/bootstrap4/jquery.slim.min.js"></script>
			<script src="https://puma-01.elettra.eu/lib/bootstrap4/bootstrap.bundle.min.js"></script>
		</head>
		<body>
		<nav class="navbar navbar-expand-sm bg-dark navbar-dark justify-content-end" style="background-color: #d9edf7 !important;">
			<ul class="navbar-nav mr-auto" id="text"><li><table><tbody><tr>
				<td><a href="./index.php" border="0"><img src="https://puma-01.elettra.eu/img/puma.svg" class="media-object" style="width:40px;height:40px; margin-left: -12px;"></a>
				</td><td><a href="./admin.php"></a><h2 style="color: black;"><a href="./admin.php">Canone3 Admin</a></h2></td><td>
			</td></tr></tbody></table></li></ul> 
		</nav>
		<div style="margin:10px;">
		<h3>Status of puma-*</h3>
		<table class="table table-hover">
		<tr><td></td><td>01</td><td>02</td><td>03</td><td>04</td><td>05</td></tr>
	';
	$servers = array('caserver async', 'caserver sync', 'ca-proxy', 'apache', 'nginx');
	exec("ps -ef |grep caserver |grep -v grep |grep -v systemctl", $res, $retval); 
	exec("ps -ef |grep apache2 |grep -v grep", $r, $retval);
	if (!empty($r[0])) $res[] = $r[0];
	exec("ps -ef |grep nginx |grep -v grep", $r2, $retval);
	if (!empty($r2[0])) $res[] = $r2[0];
	for ($j=1; $j<=5; $j++) {
		$data = $j>1? json_decode(file_get_contents("http://puma-0$j.elettra.eu/stat.php")): $res;
		foreach ($data as $d) {
			foreach ($servers as $s) {
				if (strpos($d, $s)!==false) $stat[$j][$s] = $d;
			}
		}
	}
	foreach ($servers as $s) {
		echo "<tr><td>{$s}</td>";
		for ($j=1; $j<=5; $j++) {
			if ($j>1 && ($s=='apache' || $s=='nginx')) {echo "<td>-</td>"; continue;}
			$on = !empty($stat[$j][$s]);
			echo "<td><span id='sdo' style='color: ".($on? 'green': 'red').";font-weight: bold;' title='{$stat[$j][$s]}'>".($on? 'ON': 'OFF')."</span></td>";
		}
		echo "</tr>\n";
	}
	echo "</table>\n<iframe width='100%' height='400px' style='border:0; margin:0;' src='https://pwma.elettra.eu/admin.php'></iframe></div>";
?>
