<?php
	require_once("./conf.php");
	session_start();
	if (isset($_REQUEST['debug'])) echo json_encode($_SESSION);
	$username = '';
	if (isset($_SESSION['token'])) {
		// require_once("./uti.php");
		$sql = open_db();
		$yy = date('Y');
		$webtokenExpirationSeconds = 36000; // 10 hh
		$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND EXTRACT(EPOCH FROM NOW()-date)<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
		if (!empty($data)) $username = $data[0]['username'];
	}
	// state https://tango-controls.readthedocs.io/en/latest/development/device-api/ds-guideline/device-server-guidelines.html#states-choice
	// https://tango-controls.readthedocs.io/en/latest/development/client-api/cpp-client-programmers-guide.html#data-types
	$types = array(
		"DevVoid",
        "DevBoolean",
        "DevShort",
        "DevLong",
        "DevFloat",
        "DevDouble",
        "DevUShort",
        "DevULong",
        "DevString",
        "DevVarCharArray",
        "DevVarShortArray", //10
        "DevVarLongArray",
        "DevVarFloatArray",
        "DevVarDoubleArray",
        "DevVarUShortArray",
        "DevVarULongArray",
        "DevVarStringArray",
        "DevVarLongStringArray",
        "DevVarDoubleStringArray",
        "DevState",
        "ConstDevString", // 20
        "DevVarBooleanArray",
        "DevUChar",
        "DevLong64",
        "DevULong64",
        "DevVarLong64Array",
        "DevVarULong64Array",
        "DevInt",
        "DevEncoded",
        "DevEnum",
        "DevPipeBlob", // 30
        "DevVarStateArray",
        "Unknown"
	);
	$properties = array();
	$urlArray = explode(';', $_REQUEST['varDetail']);
	$optionArray = array();
	foreach ($urlArray as $i=>$v) {
		$optionArray[$i] = false;
		if (strpos($v,'|')!==false) {
			list($urlArray[$i], $opt) = explode('|',$v);
			$optionArray[$i] = explode(',',$opt);
		}
	}
	if (isset($_REQUEST['debug'])) {echo "<br>\noptionArray<pre>"; print_r($optionArray); echo("</pre>");}
	foreach ($urlArray as $i=>$var) {
		$url = "http://pwma-dev.elettra.eu/rchan.php?src=$var&method=conf&json";
		$conf = json_decode(file_get_contents($url));
		$c = get_object_vars($conf[0]);
		$is_attr[$i] = !$conf[0]->is_command;
		$type_num = $conf[0]->in_type - 0;
		$type_coded[$i] = $types[$type_num];
		$type_desc[$i] = $conf[0]->in_type_desc;
		$is_number[$i] = in_array($type_num, array(2,3,4,5,6,7,23,24,27));
		$is_number_array[$i] = in_array($type_num, array(10,11,12,13,14,15));
		if (isset($_REQUEST['debug'])) {echo "<br>\ntype_num: $type_num, type_coded[$i]: {$type_coded[$i]}<br>\nc:<pre>"; print_r($c); echo("</pre>");}
		$properties[$i] = "<a onClick=\"$('#prop').show();\">properties</a><br>\n<ul id='prop' style='display: none;'>\n";
		foreach ($c as $k=>$v) {
			if (!is_array($v)) $properties[$i] .= "<li>$k: $v</li>\n";
		}
		$properties[$i] .= '</ul>';
	}
?>



<!-- Access-Control-Allow-Origin: *
Access-Control-Allow-Methods: GET, POST, PUT, DELETE
Access-Control-Allow-Headers: Authorization-->
<!-- jquery -->
<link rel="stylesheet" href="./lib/jquery/jquery-ui.min.css">
<script src="./lib/jquery/jquery.min.js" type="text/javascript"></script>
	<!-- Bootstrap core CSS -->
	<link href="./lib/bootstrap/bootstrap.css" rel="stylesheet">
	<!-- Bootstrap theme -->
	<link href="./lib/bootstrap/bootstrap-theme.css" rel="stylesheet">

	<!-- Bootstrap core JavaScript -->
	<script src="./lib/bootstrap/bootstrap.js"></script>
	<script src="./lib/bootstrap/docs.js"></script>
<div style='width:100%; padding:10px'>

<!-- TODO: add JQuery UI suggestion -->

	
<?php
	/* init properties
	$properties = '';
	$url = 'https://pwma.elettra.eu:10443/v1/cs/'.$_GET['varDetail'];
	$p = file_get_contents($url.'/*');
	if (!empty($p)) {
		$prop = json_decode($p, true);
		if (!empty($prop)) {
			$properties = "<a onClick=\"$('#prop').show();\">properties</a><br>\n<ul id='prop' style='display: none;'>\n";
			foreach ($prop as $p) {
				$properties .= "<li><a href='$url/$p'>$p</a></li>\n";
			}
			$properties .= "</ul>\n";
		}
	}
	$properties .= '<br>';
	*/
	function myselect($i) {
		global $optionArray;
		if (empty($optionArray[$i])) return ' pippo ';
		$buf = "<select id='argin$i'>\n";
		foreach ($optionArray[$i] as $opt) {
			$buf .= "<option value='$opt'>$opt</option>\n";
		}
		return "$buf</select><br>";
	}
	if (empty($username))
		echo "Username <input type='text' class='form-control' id='username' suggested='name.surname' />\nPassword <input type='password' class='form-control' id='password' />\n";
	else 
		echo "All operations are logged reporting username: <span style='background-color: darkgreen; color: white; padding: 5px; font-weight: bold; border-radius: 10px;'>$username</span><br>";
	foreach ($urlArray as $i=>$url) {
		$example = $is_number_array[$i]? "Ex: 2.3, 4": '';
		$param = empty($_REQUEST['param'])? '': " value=\"{$_REQUEST['param']}\"";
		echo "<h4>$url</h4>".$properties[$i].($type_coded[$i]=='DevVoid'? 'Argin type: DevVoid': (empty($optionArray[$i])? "Argin value (<span style='background-color: #e0e0e0;'>{$type_coded[$i]} - {$type_desc[$i]}</span>) $example <input type='text' class='form-control' id='argin$i'$param />": myselect($i)));
	}
?>

<br>
<input type="submit" onClick="sendStart()" value='Execute' /><br>
<?php 
	if (!empty($_REQUEST['closeDelay'])) {
		echo "<input type='checkbox' id='closeMe' checked=''> close dialog after execution<br>";
	}
?>
<div id='results'></div>
<script>
	var is_number = [<?php foreach($is_number as $n) echo ($n? "true": "false").','; ?>];
	var is_attr = [<?php foreach($is_attr as $n) echo ($n? "true": "false").','; ?>];
	var type_coded = [<?php foreach($type_coded as $n) echo "'$n',"; ?>];
	var $_GET = getQueryParams(document.location.search);
	var urlArray = $_GET['varDetail'].split('->').join('/').split(';');
	for (var i=0; i<urlArray.length; i++) {
		urlArray[i] = urlArray[i].split('|')[0];
	}
	$('#cmdName').html($_GET['varDetail'].split(';').join('<br>'));
	console.log('_GET',$_GET, urlArray);

	function getFullMonth(d) {
		var m = d.getMonth() + 1;
		if (m<10) m = '0' + m;
		return m;
	}
	function getFullDate(d) {
		var dd = d.getDate();
		if (dd<10) dd = '0' + dd;
		return dd;
	}
	function userDate(d) {
		var date = d.getFullYear() + '-' + getFullMonth(d) + '-' + getFullDate(d);
		var time = d.toLocaleTimeString().split(' ')[0];
		if (time.length < 8) time = '0'+time;
		return date + ' ' + time;
	}
	function myClose() {
		if ($('#closeMe').is(':checked')) close();
	}

	function sendStart() {
		var loggedin = <?php echo empty($username)? 'false': 'true'; ?>;
		var headers = new Headers();
		console.log('argin0', JSON.stringify({value: $('#argin0').val()-0}));
		if (!loggedin) {
			headers.append("Authorization", "Basic " + btoa(unescape(encodeURIComponent($('#username').val().split('@')[0] + ':' + $('#password').val()))));
			var startTime;
			for (i=0; i<urlArray.length; i++) {
				startTime = new Date();
				console.log(`https://pwma-dev.elettra.eu/cmd.php?cmd=${urlArray[i]}&params=${$('#argin'+i).val()}&type=${type_coded[i]}`);
				fetch(`https://pwma-dev.elettra.eu/cmd.php?cmd=${urlArray[i]}&params=${$('#argin'+i).val()}&type=${type_coded[i]}`, {
					  method: is_attr[i]? 'GET': 'POST',
					  headers: headers,
				})
				.then(resp => {
					console.log('response', resp);
					if (resp.status < 300) return resp.json();
					return {acknowledged: 'unknown', last_occurrence: 'unknown'};
				})
				.then((respJson) => {
					console.log('respJson', respJson);
					var endTime = new Date();
					var timeDiff = endTime - startTime;
					if (respJson.error) {
						$('#results').prepend(endTime.toLocaleString()+' ERROR: '+respJson.error+'<br>');
					}
					else {
						$('#results').prepend(respJson.time+' duration: '+timeDiff+' ms '+(respJson.result=='null'? 'Command OK<br>': '<pre>'+jQuery.parseJSON(respJson.result).data.value+'</pre>'));
					}
					console.log('respJson', jQuery.parseJSON(respJson.result), {t: timeDiff, response: respJson});
				})
				.catch(err => {
					console.log(`ERR: `,err);
				});
			}
		}
		else {
			var argin;
			var urls = [];
			for (i=0; i<urlArray.length; i++) {
				argin = $('#argin'+i) && $('#argin'+i).length? (is_number[i]? $('#argin'+i).val()-0: $('#argin'+i).val()): 'undefined';
				// urls[i] = (is_attr[i] && argin=='undefined')? `https://pwma.elettra.eu:10443/v1/cs/${urlArray[i]}`: `https://pwma-dev.elettra.eu/cmd.php?cmd=${urlArray[i]}&params=${argin}&type=${type_coded[i]}`;
				urls[i] = (is_attr[i] && argin=='undefined')? `https://pwma-dev.elettra.eu/cmd.php?cmd=${urlArray[i]}&type=DevVoid&params=undefined`: `https://pwma-dev.elettra.eu/cmd.php?cmd=${urlArray[i]}&params=${argin}&type=${type_coded[i]}`;
				console.log('urls[i]', urls[i]);
			}
			var startTime = new Date();
			var mytime = userDate(startTime);
			console.log('urls', urls);
			// https://stackoverflow.com/questions/31710768/how-can-i-fetch-an-array-of-urls-with-promise-all
			Promise.all(urls.map(url =>
				fetch(url, {credentials: "same-origin"}).then(resp => resp.json())
			)).then(texts => {
				// console.log('texts', texts);
				var endTime = new Date();
				var timeDiff = endTime - startTime;
				$('#results').prepend(texts[0].time+' duration: '+timeDiff+' ms <br><br>');
				for (i=0; i<texts.length; i++) {
					var respJson = texts[i];
					if (respJson.error) {
						$('#results').prepend(endTime.toLocaleString()+' ERROR: '+respJson.error+'<br>');
					}
					else {
						$('#results').prepend(respJson.cmd+'<br>'+(respJson.result=='null'? 'Command OK<br>': '<pre>'+JSON.stringify(respJson.result)+'</pre>'));
					}
					// console.log('respJson', {t: timeDiff, response: respJson});
				}
				<?php 
					if (!empty($_REQUEST['closeDelay'])) {
						echo "setTimeout(myClose, 1000*".($_REQUEST['closeDelay']-0).")";
					}
				?>
			})
		}
	}

	function getQueryParams(qs) {
		qs = qs.split("+").join(" ");
		var params = {},
						tokens,
						re = /[?&]?([^=]+)=([^&]*)/g;
		while (tokens = re.exec(qs)) {
				params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
		}
		return params;
	};
</script>
