<?php
	$ca3_host = '[my_ca3_host]'; // e.g. http://cu-elettra-arch
	$ca3_port = 8443;

	define("HOST", "127.0.0.1");
	define("USERNAME", "[my_username]");
	define("PASSWORD", "[my_password]");
	define("DB", "puma");
	$dbtype = "pg"; // can be 'pg'=PostgreSQL or 'mysqli'=MySQL

	// authentication method can be 'keycloak' or 'ldap' or 'trivial'
	define('AUTH_METHOD', 'trivial'); 
	// keycloak configurations
	define('KEYCLOAK_HOST', 'https://[my_keycloak_host]:8443');
	define('KEYCLOAK_REALM', '[my_realm]');
	define('KEYCLOAK_CLIENT_ID', 'puma');
	define('KEYCLOAK_CLIENT_SECRET', '[my_secret]');
	// ldap configurations
	define('LDAP_SERVER', '[my_ldap_host]');
	define('LDAP_DN', 'some parameters for ldap'); // e.g. 'ou=People,dc=elettra,dc=eu'

	// gitlab API integration
	define('GITLAB_API', false);
	define('GITLAB_API_TOKEN', '[my_api_token]');
	define('GITLAB_API_URL', 'https://[my_gitlab_host]/api/v4/projects/[my_project_id]');

	$admin = array('admin1', 'admin2'); // usernames of administrators
	$admin_email = ''; // email of administrators
	$ujive_users = array('admin1', 'admin2', 'user1', 'user2'); // usernames of uJive users
	$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || strpos($_SERVER["HTTP_CF_VISITOR"],'https')!==false)? 'https:': 'http:';
	$host = "$protocol//[my_host]";
	$local = false; // true: load libraries from local repository; false load from CDN 
	$elettra_screens = false; // include some screens specific for Elettra
	$domains = array(); // insert here the domain part of your tango server(s)
	$webtokenExpirationSeconds = 28800; // session expires in 8 hours
	$pwmaMobile = ''; // add here a link to download an app like PWMA Mobile '<a href="./apk/" class="button">download PWMA Mobile</a><br><br><br>';

?>
