<?php
	session_start();
	$username = '';
	require_once("./conf.php");
	require_once("./uti.php");
	$sql = open_db();
	if (isset($_SESSION['token'])) {
		$yy = date('Y');
		$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
		if (!empty($data)) {
			$un = explode('@', $data[0]['username']);
			$username = strtolower($un[0]);
		}
	}
	if (empty($username)) {
		emit_header();
		die("&nbsp;Page available only for authorized users. If you are authorized, please <a href='./'>login</a>.");
	}
	else if (!is_dir("./spa/usr/".$username)) {
		emit_header();
		die('<div style="margin: 10px;">'.
			"Page available only for authorized users.<br>Your username still isn't authorized, please read and accept this notice
		<iframe style='width: 100%; height: 20em;' src='./spa/usr/licence_1.1.html'></iframe>
		and send an <a href='mailto:{$admin_email}?subject=Authorization%20request&body=Please%20authorize%20{$username}%20as%20PUMA%20advanced%20developer%2E%20I%20accept%20the%20developer%20notice%201%2E0'>authorization request</a>.</div>");
	}

	// ----------------------------------------------------------------
	// emit header
	function emit_header() {
		global $username, $local;
		echo "		<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
			<script src='https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js'></script>
			<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
			<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js'></script>
			<link rel='stylesheet' href='./spa/css/style.css'>
		</head>\n";
		echo '<nav class="navbar navbar-default">
	  <div class="container-fluid bg-info">
		<div class="navbar-header">
		  <a class="navbar-brand" href="./starter.php"><img src="./img/logo.png" style="width:40px; height:40px; margin-top: -10px; margin-left: -5px; display: inline;"> 
		  <span style="font-size: 150%; font-weight: bolder; color: black">PUMA Editor
		  <!--h2 style="color: black">PUMA</h2--></span></a>
		  <ul style="float: right"><!--class="nav navbar-form navbar-right"-->
			 <div>';
		if (!empty($username)) {
			echo '
			  <form method="post" action="./starter.php" style="margin: 0px;">welcome '.$username.' <button type="submit" name="logout" class="btn btn-default">Logout</button></form>';
		}
		echo '
			<script>
				document.body.style.fontSize = "2em";
				if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/)!=null && window.innerWidth>600) {
					document.body.style.fontSize = "5em";
				}
			</script>
			 </div>
		  </ul>
		</div>
	  </div>
	</nav>
	<div style="margin: 5px;">';
	}


	if (isset($_REQUEST['saveadmin'])) {
		debug($_REQUEST);
		$sc = $sql->sql_secure("SELECT * FROM screencategory WHERE id=$1", array($_REQUEST['saveadmin']));
		debug($sc);
		$id = array();
		foreach (explode(',', $_REQUEST['category']) as $c) {
			$d = $sql->sql_secure("SELECT id FROM screencategory WHERE description = $1 ", array($c));
			$id[] = $d[0]['id'];
		}
		$cat = '{'.implode(',',$id).'}';
		if ($_REQUEST['name'] != $sc[0]['description'] || $cat != $sc[0]['category']) {
			$query = "UPDATE screencategory SET description=$1, category='$cat' WHERE id=$2"; 
			$sql->sql_secure($query, array($_REQUEST['name'], $_REQUEST['saveadmin']));
			echo $sql->sql_error();
			debug($query);
		}
		$us = $sql->sql_secure("SELECT * FROM usercategory", array());
		$newusers = explode(',', $_REQUEST['users']);
		if (!empty($us)) foreach ($us as $s) {
			echo "<hr>"; debug($s);
			$usercat = array();
			if (!empty($s['category'])) $usercat = explode(',',trim($s['category'],'{}'));
			$userkey = array_search($s['username'], $newusers);
			if (in_array($_REQUEST['saveadmin'], $usercat)) {
				if ($userkey === false) {
					$c = strtr(strtr($s['category'], array($_REQUEST['saveadmin']=>'')),array(',,'=>','));
					$query = "UPDATE usercategory SET category='$c' WHERE username=$1";
					$sql->sql_secure($query, array($s['username']));
					echo $sql->sql_error();
					debug($query); debug($s['username']);
				}
			}
			else {
				if ($userkey !== false) {
					$c = strtr(strtr($s['category'], array('}'=>",{$_REQUEST['saveadmin']}}")),array('{,'=>'{'));
					$query = "UPDATE usercategory SET category='$c' WHERE username=$1";
					$sql->sql_secure($query, array($s['username']));
					echo $sql->sql_error();
					debug($newusers);
					unset($newusers[$userkey]);
					debug($newusers);
					debug($query); debug($s['username']);
				}
			}
			if ($userkey !== false) {
				debug($newusers);
				unset($newusers[$userkey]);
				debug($newusers);
			}
		}
		if (!empty($newusers)) foreach($newusers as $u) {
			$query = "INSERT INTO usercategory (username,category) VALUES ($1,'{{$_REQUEST['saveadmin']}}')";
			$sql->sql_secure($query, array($u));
			echo $sql->sql_error();
			debug($query); debug($u);
		}
		echo "<hr>";
		debug($newusers);
		$exit = isset($_REQUEST['exit'])? '': '='.$_REQUEST['saveadmin'];
		die("<script>\ndocument.location = './group.php?admin$exit'</script>");
	}
	if (isset($_REQUEST['save'])) {
		$cat = '{'.$_REQUEST['save'].'}';
		$data = $sql->sql_secure("UPDATE screen SET category='$cat' WHERE id=$1", array($_REQUEST['screenid']));
		// $data = $sql->sql_secure("UPDATE screen SET category='{2}' WHERE id=$1", array($_REQUEST['screenid']));
		echo $sql->sql_error();
		die("<body onload='window.opener.myClose()'>
			saved;
		</body>");
	}
	emit_header();
	if (isset($_REQUEST['admin']) && in_array($username, $admin)) {
		$category = array();
		$sc = $sql->sql_secure("SELECT * FROM screencategory", array());
		foreach ($sc as $s) {
			$cat = array();
			if (!empty($s['category'])) $cat = explode(',',trim($s['category'],'{}'));
			$category[$s['id']] = array('name'=>$s['description'], 'category'=>$cat);
		}
		$us = $sql->sql_secure("SELECT * FROM usercategory", array());
		$users = array();
		foreach ($us as $s) {
			$cat = array();
			if (!empty($s['category'])) $cat = explode(',',trim($s['category'],'{}'));
			$users[] = array('name'=>$s['username'], 'category'=>$cat);
		}
		if (!empty($_REQUEST['admin'])) {
			$cid = $_REQUEST['admin']-0;
			echo "Group: {$category[$cid]['name']}<br><sub>Warning: only trivial recursive loops are automatically detected</sub><br><br>\n
				<script>
					function myAdd() {
						console.log('myAdd()', $('#adduser').val());
						$('.container').append(\"<input type='checkbox' class='us' value='\"+$('#adduser').val()+\"' checked> \"+$('#adduser').val()+\"<br>\");
					}
					function myModify(exit) {
						var cb = $('.cb');
						var cat = [];
						for (var i=0; i<cb.length; i++) {
							if (cb[i].checked) cat.push(cb[i].value);
						}
						var us = $('.us');
						var res = [];
						for (var i=0; i<us.length; i++) {
							if (us[i].checked) res.push(us[i].value);
						}
						console.log('myModify()', $('#name').val(), cat, res);
						document.location = './group.php?saveadmin=$cid&name='+$('#name').val()+'&category='+cat.join(',')+'&users='+res.join(',')+(exit? '&exit': '');
					}
				</script>
				<table class='table table-bordered table-hover table-striped'>\n";
			echo "<tr><td> Name </td><td><input type='text' id='name' value='{$category[$cid]['name']}'></td></tr>\n";
			$options = array(); foreach ($category as $k=>$c) if ($k!=$cid && !in_array($cid,$c['category'])) {
				$checked = in_array($k,$category[$cid]['category'])? ' checked': '';
				$options[] = "<input type='checkbox' class='cb' value='{$c['name']}'$checked> {$c['name']}<br>\n";
			}
			echo "<tr valign='top'><td> Contained in </td><td>".implode('', $options)."</td></tr>\n";
			$options = array(); foreach ($users as $k=>$c) if (in_array($cid,$c['category'])) {
				$options[] = "<input type='checkbox' class='us' value='{$c['name']}' checked> {$c['name']}<br>\n";
			}
			echo "<tr valign='top'><td> Users </td><td><div class='container' style='padding-left: 0px;'>".implode('', $options)."</div><input type='text' id='adduser'> <button class='btn btn-secondary' onclick='myAdd()'>add</button></td></tr>\n";
			die("</table><button class='btn btn-primary' onClick='myModify(0)'>save</button>&nbsp;&nbsp;&nbsp;<button class='btn btn-primary' onClick='myModify(1)'>save and exit</button>\n");
		}
		echo "Group management<br><br>\n<table class='table table-bordered table-hover table-striped' style='width: 90%;'>\n<tr><td> Name </td><td> Contained in </td><td> Users </td><td> &nbsp; </td></tr>\n";
		foreach ($category as $key=>$val) {
			$subcat = array(); foreach($val['category'] as $subc) $subcat[] = $category[$subc]['name'];
			$subcategory = implode(',', $subcat);
			$subusr = array(); foreach($users as $subu) if (in_array($key, $subu['category'])) $subusr[] = $subu['name'];
			$subuser = implode("<br>\n", $subusr);
			echo "<tr><td> {$val['name']} </td><td> $subcategory </td><td> $subuser </td><td> <button class='btn btn-primary' onClick=\"document.location = '?admin=$key'\">edit</button> </td></tr>\n";
		}
		die("</table>");
		debug($users);
		debug($category);
	}
	if (!empty($_REQUEST['screenid'])) {
		$cat = $sql->sql_secure("SELECT * FROM screencategory", array());
		$category = array();
		foreach ($cat as $c) {
			$category[$c['id']] = $c['description'];
		}
		$data = $sql->sql_secure("SELECT id,title,category FROM screen WHERE id=$1", array($_REQUEST['screenid']));
		$name = strip_tags($data[0]['title']);
		$c = explode(',', trim($data[0]['category'], '{}'));
		echo "<h2 style='color: darkgreen;'>$name</h2>\ngroups management<br><br>\n<table class='table table-bordered table-hover table-striped' style='width: 90%;'>\n";
		foreach ($category as $key=>$val) {
			$checked = in_array($key, $c)? ' checked': '';
			echo "<tr><td><input type='checkbox' class='cb' value='$key'$checked> $val</td></tr>\n";
		}
		die("</table>
		<script>
			function saveCategory() {
				var cb = $('.cb');
				var res = [];
				for (var i=0; i<cb.length; i++) {
					console.log(i, cb[i].checked, cb[i].value);
					if (cb[i].checked) res.push(cb[i].value);
				}
				document.location = './group.php?save='+res.join(',')+'&screenid=".($_REQUEST['screenid']-0)."';
			}
		</script>
		<button class='btn btn-primary' onClick='saveCategory()'>Save</button>");
	}
	echo "groups management";
?>
