CREATE DATABASE puma;
USE puma;

CREATE TABLE alarm (
  label varchar(20),
  tokenid INT
);

CREATE TABLE alarmlog (
  label varchar(20),
  tokenid INT,
  date timestamp,
  ack bool NOT NULL,
  subscribe bool NOT NULL,
  rtvalue bool NOT NULL
);

CREATE TABLE cmdlog_2021 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);

CREATE TABLE cmdlog_2022 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);

CREATE TABLE cmdlog_2023 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2024 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2025 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2026 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2027 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2028 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2029 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdlog_2030 (
  username text,
  date timestamp,
  ip VARCHAR(50),
  cmd text,
  param text NOT NULL
);


CREATE TABLE cmdunrestricted (
  src varchar(250)
);


CREATE TABLE domain (
  label varchar(20),
  value text NOT NULL
);

CREATE TABLE formula (
  label varchar(20),
  formula text NOT NULL,
  note text NOT NULL,
  datemodified timestamp NOT NULL,
  ip VARCHAR(50) NOT NULL,
  username text NOT NULL,
  dateexpiration timestamp NOT NULL,
  domain varchar(20) NOT NULL,
  system varchar(100) NOT NULL,
  delay float4 NOT NULL
);

CREATE TABLE formulalog_2021 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2022 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2023 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2024 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2025 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2026 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2027 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2028 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2029 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);


CREATE TABLE formulalog_2030 (
  label varchar(20),
  formula text NOT NULL,
  tokenid INT NOT NULL,
  username text NOT NULL,
  ip VARCHAR(50) NOT NULL,
  date timestamp,
  dateexpiration timestamp NOT NULL,
  delay float4 NOT NULL
);

CREATE TABLE `screen` (
 `id` int(10) NOT NULL AUTO_INCREMENT,
 `username` varchar(50) NOT NULL,
 `ip` varchar(50) NOT NULL,
 `title` varchar(200) NOT NULL,
 `created_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
 `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
 `content` text NOT NULL,
 PRIMARY KEY (`id`)
);

CREATE TABLE screenlog_2021 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);

CREATE TABLE screenlog_2022 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2023 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2024 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2025 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2026 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2027 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2028 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2029 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE screenlog_2030 (
  username varchar(50),
  id INT,
  valid_until timestamp,
  title varchar(200),
  content TEXT
);


CREATE TABLE `starter` (
 `username` text,
 `screens` text NOT NULL,
 `datemodified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
 `tree_filter_default` varchar(100) DEFAULT NULL
);

CREATE TABLE starterlog_2021 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);

CREATE TABLE starterlog_2022 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2023 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2024 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2025 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2026 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2027 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2028 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2029 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE starterlog_2030 (
  username text NOT NULL,
  screens text NOT NULL,
  datemodified timestamp NOT NULL
);


CREATE TABLE token (
  value text NOT NULL,
  username varchar(100) NOT NULL
);


CREATE TABLE tree_filter (
  last_update timestamp NOT NULL,
  title varchar(200) NOT NULL,
  owner varchar(50) NOT NULL,
  content TEXT NOT NULL
);

CREATE TABLE userlog_2021 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2022 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2023 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2024 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2025 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2026 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2027 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2028 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2029 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);


CREATE TABLE userlog_2030 (
  username text,
  ip VARCHAR(50) NOT NULL,
  webtoken varchar(100) NOT NULL,
  date timestamp
);

CREATE TABLE userscreenlog_2021 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2022 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2023 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2024 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2025 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2026 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2027 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2028 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2029 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);


CREATE TABLE userscreenlog_2030 (
  username varchar(50),
  screenid INT,
  filename varchar(100),
  date timestamp,
  ip VARCHAR(50) NOT NULL
);
