<?php
	require_once('./conf/conf.php');
	$yy = date('Y');
	$h = explode('.', gethostbyaddr($_SERVER['REMOTE_ADDR']));
	$host = isset($_REQUEST['host'])? $_REQUEST['host']: $h[0];
	function read_conf() {
		global $host, $fermihosts;
		$context = stream_context_create(array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
		$file = file_get_contents('./conf/launcher.json');
		if (empty($file) || time() - filemtime('./conf/launcher.json') > 86400*7) {
			$file = file_get_contents('https://gitlab.elettra.eu/puma/client/web/-/raw/master/knob/conf/launcher.json', false, $context);
			if (!empty($file) && $file{0} === '[') file_put_contents('./conf/launcher.json', $file);
		}
		// if (!isset($_REQUEST['debug'])) $file = file_get_contents('https://gitlab.elettra.eu/puma/client/web/-/raw/master/knob/launcher.json', false, $context);
		// if (empty($file) || $file{0} !== '[') $file = file_get_contents('./conf/launcher.json');
		// else if (time() - filemtime('./conf/launcher.json') > 86400*7) file_put_contents('./conf/launcher.json', $file);
		$f = json_decode($file, true);
		$facility = 'all';
		if (strpos($host,'pcl-elettra-cr')!==false) $facility = 'elettra';
		if (in_array($host, $fermihosts)) $facility = 'fermi';
		$conf = array();
		foreach ($f as $i) foreach($i as $k=>$v) {
			if ($facility != 'all' && $facility != $v['facility']) continue;
			$wsa = explode(',', $v['workstation']);
			foreach ($wsa as $ws) $conf[$ws][$k] = $v;
		}
		if (isset($_REQUEST['debug'])) {echo "$host<pre>"; print_r($conf); echo "</pre>";}
		return $conf;
	}
	if (isset($_REQUEST['start'])) {
		$token = rand();
		$a = file_put_contents(TMPFILE."{$host}_seed", $token);
		file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." $host start $token\n", FILE_APPEND | LOCK_EX);
		echo "$token"; 
	}
	if (isset($_REQUEST['stop'])) {
		$s = file_get_contents(TMPFILE."{$host}_seed");
		if ($s !== $_REQUEST['stop']) exit(0);
		file_put_contents(TMPFILE.$host, '');
		file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." $host stop {$_REQUEST['stop']}\n", FILE_APPEND | LOCK_EX);
		echo "OK"; 
	}
	else if (isset($_REQUEST['debughost'])) {
		echo gethostbyaddr($_SERVER['REMOTE_ADDR'])."<br>\n";
		$s = file_get_contents(TMPFILE.$_REQUEST['host'].'_seed');
		die($s);
	}
	else if (isset($_REQUEST['stat']) && !empty($host) && file_exists(TMPFILE."{$host}_seed")) {
		$s = file_get_contents(TMPFILE."{$host}_seed");
		if ($s !== $_REQUEST['stat'])  {file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." debug sent not to $host -- $s !== {$_REQUEST['stat']}\n", FILE_APPEND | LOCK_EX); exit();}
		$f = file_get_contents(TMPFILE.$host);
		$t = time();
		$emergency = '';
		while (empty($f) && time()-$t < 3600) {
			sleep(1);
			$f = file_get_contents(TMPFILE.$host);
			if (file_exists(TMPFILE."emergency")) $emergency = file_get_contents(TMPFILE."emergency");
			if (strpos($emergency,'stop')!==false) {
				header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
				exit();
			}
		}
		if (file_exists(TMPFILE."emergency")) $emergency = file_get_contents(TMPFILE."emergency");
		if (strpos($emergency,'stop')!==false) {
			header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			exit();
		}
		$s = file_get_contents(TMPFILE."{$host}_seed");
		if ($s !== $_REQUEST['stat']) {file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." debug not sent to $host\n", FILE_APPEND | LOCK_EX); exit();}
		if (empty($f)) {/*file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." debug don't send to $host\n", FILE_APPEND | LOCK_EX); */ exit();}
		echo file_get_contents(TMPFILE.$host);
		file_put_contents(TMPFILE.$host, '');
		file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." sent to $host\n", FILE_APPEND | LOCK_EX);
	}
	else if (isset($_REQUEST['nokill'])) {
		file_put_contents(TMPFILE.$_REQUEST['host'], "nokill\n100 100 ".$_REQUEST['nokill']);
		file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." cmd {$_REQUEST['nokill']} to {$_REQUEST['host']} from $remote_ip $remote_host\n", FILE_APPEND | LOCK_EX);
	}
	else if (isset($_REQUEST['cmd'])) {
		$c = read_conf();
		$conf = array();
		foreach ($c as $k => $v) $conf += $v;
		// die(print_r($conf, true));
		if (empty($_REQUEST['host'])) {sleep(2);file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." Error: empty host\n", FILE_APPEND | LOCK_EX);exit();}
		$remote_ip = $_SERVER['REMOTE_ADDR'];
		$remote_host = gethostbyaddr($ip);
		if ($_REQUEST['cmd']=='clear') {file_put_contents(TMPFILE.$_REQUEST['host'], ''); exit();}
		if (!isset($conf[$_REQUEST['cmd']])) {sleep(2);file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." cmd not faund {$_REQUEST['cmd']}\n", FILE_APPEND | LOCK_EX); exit();}
		$exename = array();
		foreach ($conf[$_REQUEST['cmd']]['cmd'] as $e) $exename[] = "{$e['x']} {$e['y']} {$e['exename']}";
		file_put_contents(TMPFILE.$_REQUEST['host'], implode("\n", $exename));
		file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." cmd {$_REQUEST['cmd']} to {$_REQUEST['host']} from $remote_ip $remote_host\n", FILE_APPEND | LOCK_EX);
	}
	else if (isset($_REQUEST['cmdlist'])) {
		$template = file_get_contents('./cmdlist.html');
		$param = "?host=$host";
		$link = isset($_REQUEST['tabletwheel'])? " <a class='btn btn-secondary' style='width: 100%;' href='/knob/tabletwheel.html$param'>go to knob</a>": " <a class='btn btn-secondary' style='width: 100%;' href='/knob/index.php$param'>go to knob</a>";
		$list = "";
		$conf = read_conf();
		$fermiIndex = array_search($host, $fermihosts);
		for ($i=0; $i<count($fermihosts); $i++) {
			$j = ($i + $fermiIndex) % count($fermihosts);
			if (empty($conf[$fermihosts[$j]])) continue;
			$list .= "<div class='card'>\n<h5 class='card-header'>{$fermihosts[$j]}</h5>\n<div class='card-body'>\n<table style='margin-left: 5px;'>";
			foreach ($conf[$fermihosts[$j]] as $k=>$v) {
				$list .= "<tr><td><button style='width: 100%; margin-bottom:8px; margin-top:5px;'' class='btn btn-primary' onclick=\"myexec('$k')\">{$v['label']}</button> </td><td>&nbsp;&nbsp;{$v['description']}</td></tr>\n";
			}
			$list .= "</table></div></div>";
		}
		$emergency = 'false';
		$emef= file_get_contents(TMPFILE."emergency");
		if (!empty($emef) && strpos($emef,'stop')!==false) {
			$emergency = 'true';
		}
		$stat = file_get_contents("http://pwma.elettra.eu/knob/index.php?cmd=status&ws=$host&pw=?");
		$hcolor = strpos($stat,'poslauncher')===false? 'red': 'black';
		if (isset($_REQUEST['debug'])) echo "http://pwma.elettra.eu/knob/index.php?cmd=status&ws=$host<br>$stat<br>$hcolor<br>";
		die(strtr($template, array('<!--list-->'=>$list,'<!--host-->'=>$host,'<!--hcolor-->'=>$hcolor,'<!--emergency-->'=>$emergency,'<!--link-->'=>$link)));
	}

?>
